/* inetserial.c: Experimental interface layer to pi-port via TCP/IP
 *
 * Copyright (c) 1996, 1997,  D. Jeff Dionne & Kenneth Albanowski.
 * This is free software, licensed under the GNU Public License V2.
 * See the file COPYING for details.
 */
#ifdef QDOS
#include <sys/bsdtypes.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include "pi-source.h"
#include "pi-socket.h"
#include "pi-serial.h"
#include "pi-inetserial.h"
#include "pi-slp.h"
#include "pi-syspkt.h"
#include "pi-padp.h"

#ifdef OS2
#include <sys/select.h>
#endif

static int n_changebaud(struct pi_socket *ps);
static int n_close(struct pi_socket *ps);
static int n_write(struct pi_socket *ps);
static int n_read(struct pi_socket *ps, int timeout);

int pi_inetserial_open(struct pi_socket *ps, struct sockaddr * addr, int addrlen)
{
    ps->mac->fd = -1;
    return ps->mac->fd;
}

static int n_changebaud(struct pi_socket *ps)
{
  return 0;
}

static int n_close(struct pi_socket *ps)
{
  return -1;
}

static int n_write(struct pi_socket *ps)
{
  return -1;
}

static int n_read(struct pi_socket *ps, int timeout)
{
  return -1;    
}

