diff -r -w -b -N -c /opt/src/pilot-link/Makefile.qdos ./Makefile.qdos
*** /opt/src/pilot-link/Makefile.qdos	Thu Jan  1 01:00:00 1970
--- ./Makefile.qdos	Sun Feb 28 19:09:27 1999
***************
*** 0 ****
--- 1,306 ----
+ # Generated automatically from Makefile.in by configure.
+ 
+ srcdir = .
+ top_builddir = .
+ bindir = /ql/exe/
+ INSTALL_PROGRAM = qcp
+ 
+ PURELINK =
+ PURIFY =
+ 
+ # Libraries needed to link with Tcl & (optionally) Tk
+ #TCLTK_LIBS = -L/usr/local/lib -ltk -L/usr/local/lib -ltcl -L/usr/X11R6/lib -lX11 -ldl  -lm # was -lieee
+ # Include directives needed to compile with Tcl & Tk, and
+ # -DTCL if Tcl is available, and
+ # -DTK if Tk is available.
+ #TCLTK_FLAGS = -DTCL -DTK -I/usr/local/include
+ 
+ # Libraries needed to link with GNU readline
+ #RLLIBS = -lreadline
+ # Include directives needed to compile with GNU readline, and
+ # -DREADLINE_2_0 if GNU readline 2.0 is available, or 
+ # -DREADLINE_2_1 if GNU readline 2.1 (or later) is available.
+ #RLDEFS = -DREADLINE_2_1
+ 
+ libdir = ./libsock/
+ CC = qcc
+ #CXX = c++
+ CDEFS = 
+ # -DDEBUG
+ CFLAGS = -I./include -I$(srcdir)/include -O $(RLDEFS) $(CDEFS) $(TCLTK_FLAGS)
+ LDFLAGS = 
+ LIBS =  -lm
+ PILINK = -L libsock/ -lpisock -lpisock -lpisock -lsocket 
+ # -lefence
+ #CXXLIBS =  -lg++
+ 
+ #libcclib = libcc/libpicc.a
+ #cclib = libpicc.a
+ 
+ YACC = bison -y
+ RANLIB = ranlib
+ RM = rm -f
+ STRIP = strip
+ SHELL = /bin/sh
+ CPLIB = cp
+ EXT = 
+ SUBMAKE_COMM = cd $(top_builddir)/libsock ; $(MAKE) -f Makefile.qdos
+ #SUBMAKE_COMM_DUBIOUS = cd $(top_builddir)/dubious ; $(MAKE) 
+ #SUBMAKE_COMM_CC = cd $(top_builddir)/libcc ; $(MAKE) 
+ 
+ #LIBTOOL = $(top_builddir)/libtool
+ #LIBTOOLLINK = $(LIBTOOL) --mode=link
+ 
+ CCLINK = $(LIBTOOLLINK)  $(PURELINK) $(PURIFY) $(CC) $(LDFLAGS) $(CFLAGS)
+ #CXXLINK = $(LIBTOOLLINK) $(PURELINK) $(PURIFY) $(CXX) $(LDFLAGS) $(CXXFLAGS)
+ 
+ .SUFFIXES: .out .o .cc .c .e .r .f .y .l .s .p
+ 
+ .c.o:
+ 	$(CC) $(CFLAGS) -c $<
+ 
+ #.cc.o:
+ #	$(CXX) $(CXXFLAGS) -c $<
+ 
+ 
+ #WITHTCL = $(TCLEXECS)
+ #WITHCXX = $(CXXEXECS)
+ #WITHPERL5 = $(PERLEXECS)
+ 
+ CEXECS = pilot-xfer$(EXT) pilot-file$(EXT) pilot-dedupe$(EXT) pilot-schlep$(EXT)\
+ 		install-memo$(EXT) install-user$(EXT) install-datebook$(EXT)\
+ 		install-todos$(EXT) pilot-addresses$(EXT) pilot-clip$(EXT)\
+ 		pilot-mail$(EXT) read-expenses$(EXT) $(CCEXECS) \
+ 	    reminders$(EXT) memos$(EXT) addresses$(EXT) read-todos$(EXT)\
+ 		debugsh$(EXT) dlpsh$(EXT) \
+ 		pi-port$(EXT)
+ 
+ CXXEXECS = # ccexample$(EXT) iambicexample$(EXT)
+ 
+ TCLEXECS = #pilot-debug$(EXT)
+ 
+ PERLEXECS = #pilot-undelete ietf2datebook sync-plan
+ 
+ EXECS = $(CEXECS) $(WITHTCL) $(WITHCXX) $(WITHPERL5)
+ 
+ PILIB = libsock/libpisock.a
+ #PICCLIB = libcc/libpicc.a
+ 
+ all: $(EXECS)
+ 
+ 
+ $(PILIB): FORCE
+ 	$(SUBMAKE_COMM) libpisock.a
+ 
+ #libcc/libpicc.a: FORCE
+ #	$(SUBMAKE_COMM_CC) libpicc.a
+ 
+ 
+ pilot-dedupe$(EXT): $(PILIB) pilot-dedupe.o
+ 	$(CCLINK) pilot-dedupe.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-xfer$(EXT): $(PILIB) pilot-xfer.o
+ 	$(CCLINK) pilot-xfer.o $(PILINK) -o $@ $(LIBS)
+ 	qcp pilot-xfer /ql/exe/
+ 
+ pilot-schlep$(EXT): $(PILIB) pilot-schlep.o
+ 	$(CCLINK) pilot-schlep.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-mail$(EXT): $(PILIB) pilot-mail.o parsedate.o
+ 	$(CCLINK) pilot-mail.o parsedate.o $(PILINK) -o $@ $(LIBS)
+ 
+ pi-port$(EXT): $(PILIB) pi-port.o
+ 	$(CCLINK) pi-port.o $(PILINK) -o $@ $(LIBS)
+ 
+ #pi-getrom$(EXT): $(PILIB) pi-getrom.o
+ #	$(CCLINK) pi-getrom.o $(PILINK) -o $@ $(LIBS)
+ 
+ #pi-getram$(EXT): $(PILIB) pi-getram.o
+ #	$(CCLINK) pi-getram.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-file$(EXT): $(PILIB) pilot-file.o
+ 	$(CCLINK) pilot-file.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-clip$(EXT): $(PILIB) pilot-clip.o
+ 	$(CCLINK) pilot-clip.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-debug.o: pilot-debug.c Makefile
+ 	$(CC) -DTK $(CFLAGS) -c pilot-debug.c
+ 
+ pd-tty.o: pd-tty.c Makefile
+ 	$(CC) $(CFLAGS) -c pd-tty.c
+ 
+ pilot-debug$(EXT): $(PILIB) pilot-debug.o pd-tty.o
+ 	$(CCLINK) pilot-debug.o pd-tty.o $(PILINK) -o $@ $(TCLTK_LIBS) $(RLLIBS) $(LIBS)
+ 
+ reminders$(EXT): $(PILIB) reminders.o
+ 	$(CCLINK) reminders.o $(PILINK) -o $@ $(LIBS)
+ 
+ memos$(EXT): $(PILIB) memos.o
+ 	$(CCLINK) memos.o $(PILINK) -o $@ $(LIBS)
+ 
+ read-todos$(EXT): $(PILIB) read-todos.o
+ 	$(CCLINK) read-todos.o $(PILINK) -o $@ $(LIBS)
+ 
+ read-expenses$(EXT): $(PILIB) read-expenses.o
+ 	$(CCLINK) read-expenses.o $(PILINK) -o $@ $(LIBS)
+ 
+ #read-ical$(EXT): $(PILIB) read-ical.o
+ #	$(CCLINK) read-ical.o $(PILINK) -o $@ $(LIBS)
+ 
+ addresses$(EXT): $(PILIB) addresses.o
+ 	$(CCLINK) addresses.o $(PILINK) -o $@ $(LIBS)
+ 
+ dlpsh$(EXT): $(PILIB) dlpsh.o
+ 	$(CCLINK) dlpsh.o $(PILINK) -o $@ $(LIBS)
+ 
+ debugsh$(EXT): $(PILIB) debugsh.o
+ 	$(CCLINK) debugsh.o $(PILINK) -o $@ $(LIBS)
+ 
+ pilot-addresses$(EXT): $(PILIB) pilot-addresses.o
+ 	$(CCLINK) pilot-addresses.o $(PILINK) -o $@ $(LIBS)
+ 
+ #getrom$(EXT): $(PILIB) getrom.o
+ #	$(CCLINK) getrom.o $(PILINK) -o $@ $(LIBS)
+ 
+ install-memo$(EXT): $(PILIB) install-memo.o
+ 	$(CCLINK) install-memo.o $(PILINK) -o $@ $(LIBS)
+ 
+ install-datebook$(EXT): $(PILIB) install-datebook.o parsedate.o
+ 	$(CCLINK) install-datebook.o parsedate.o $(PILINK) -o $@ $(LIBS)
+ 
+ install-todos$(EXT): $(PILIB) install-todos.o
+ 	$(CCLINK) install-todos.o $(PILINK) -o $@ $(LIBS)
+ 
+ install-user$(EXT): $(PILIB) install-user.o
+ 	$(CCLINK) install-user.o $(PILINK) -o $@ $(LIBS)
+ 
+ parsedate.c: parsedate.y
+ 	@echo Expect six shift/reduce conflicts
+ 	$(YACC) parsedate.y
+ 	mv y.tab.c parsedate.c
+ 
+ distclean: clean depend os2
+ 	$(RM) Makefile libsock/Makefile dubious/Makefile include/pi-config.h
+ 	$(RM) libcc/Makefile
+ 	$(RM) config.log config.status config.cache libtool
+ 	$(RM) PiDebug.log
+ 	-cd Perl5 ; $(MAKE) realclean ; rm Makefile.PL
+ 	-cd Python ; $(MAKE) distclean
+ 	-cd Tcl ; $(MAKE) clean
+ 	-cd Java ; $(MAKE) distclean
+ 	-cd tests ; $(MAKE) distclean
+ 	$(RM) *~ *.orig */*~ */*.orig
+ 	$(RM) Tcl/Makefile Perl5/Makefile.PL Perl5/Makefile Python/Makefile
+ 
+ clean:
+ 	$(RM) *.o *.a *.lo *.la core a.out tarball test_s test_c install-prc$(EXT) pilot-debug$(EXT)
+ 	$(RM) -rf .libs _libs
+ 	$(RM) $(CEXECS) $(TCLEXECS) $(CXXEXECS) $(PERLEXECS) validate 
+ 	$(RM) pilot.rom* pilot2.rom* sync-plan.ids.*
+ 	$(SUBMAKE_COMM) clean
+ 
+ 
+ tarball: distclean
+ 	gcc -o tarball scripts/tarball.c -Iinclude
+ 	./tarball
+ 
+ install: $(EXECS)
+ 	cp $(libdir)/libpisock.a /usr/local/qdos/include/
+ 	for p in $(EXECS); do \
+ 		$(INSTALL_PROGRAM) $$p $(bindir)/; \
+ 	done
+ 
+ #Depend information starts here. Do not edit the text beyond this point!
+ addresses.o: addresses.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-address.h include/pi-appinfo.h include/pi-dlp.h
+ debugsh.o: debugsh.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-syspkt.h
+ dlpsh.o: dlpsh.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-padp.h include/pi-dlp.h include/pi-serial.h
+ getrom.o: getrom.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-serial.h
+ install-datebook.o: install-datebook.c include/pi-source.h \
+  include/pi-config.h include/pi-socket.h include/pi-args.h \
+  include/pi-macros.h include/pi-dlp.h include/pi-datebook.h \
+  include/pi-appinfo.h
+ install-memo.o: install-memo.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-memo.h include/pi-appinfo.h
+ install-todos.o: install-todos.c include/pi-source.h \
+  include/pi-config.h include/pi-socket.h include/pi-args.h \
+  include/pi-macros.h include/pi-dlp.h include/pi-todo.h \
+  include/pi-appinfo.h
+ install-user.o: install-user.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h
+ memos.o: memos.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-memo.h include/pi-appinfo.h include/pi-dlp.h
+ parsedate.o: parsedate.c
+ pd-tty.o: pd-tty.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-syspkt.h
+ pi-csd.o: pi-csd.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-serial.h include/pi-slp.h
+ pi-getram.o: pi-getram.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-syspkt.h include/pi-dlp.h
+ pi-getrom.o: pi-getrom.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-syspkt.h include/pi-dlp.h
+ pi-nredir.o: pi-nredir.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h
+ pi-port.o: pi-port.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-serial.h include/pi-slp.h
+ pilot-addresses.o: pilot-addresses.c include/pi-source.h \
+  include/pi-config.h include/pi-socket.h include/pi-args.h \
+  include/pi-macros.h include/pi-dlp.h include/pi-address.h \
+  include/pi-appinfo.h
+ pilot-clip.o: pilot-clip.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-syspkt.h include/pi-dlp.h
+ pilot-debug.o: pilot-debug.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-syspkt.h
+ pilot-dedupe.o: pilot-dedupe.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h
+ pilot-file.o: pilot-file.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-file.h
+ pilot-mail.o: pilot-mail.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-mail.h include/pi-appinfo.h include/pi-dlp.h
+ pilot-prc.o: pilot-prc.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-dlp.h include/pi-file.h
+ pilot-schlep.o: pilot-schlep.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-file.h include/pi-dlp.h
+ pilot-xfer.o: pilot-xfer.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-file.h include/pi-dlp.h
+ read-expenses.o: read-expenses.c include/pi-source.h \
+  include/pi-config.h include/pi-socket.h include/pi-args.h \
+  include/pi-macros.h include/pi-expense.h include/pi-appinfo.h \
+  include/pi-dlp.h
+ read-ical.o: read-ical.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-todo.h include/pi-appinfo.h include/pi-datebook.h \
+  include/pi-dlp.h
+ read-todos.o: read-todos.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-todo.h include/pi-appinfo.h include/pi-dlp.h
+ reminders.o: reminders.c include/pi-source.h include/pi-config.h \
+  include/pi-socket.h include/pi-args.h include/pi-macros.h \
+  include/pi-datebook.h include/pi-appinfo.h include/pi-dlp.h
+ 
+ FORCE:
diff -r -w -b -N -c /opt/src/pilot-link/README.QDOS ./README.QDOS
*** /opt/src/pilot-link/README.QDOS	Thu Jan  1 01:00:00 1970
--- ./README.QDOS	Mon Mar  1 21:56:16 1999
***************
*** 0 ****
--- 1,36 ----
+ Introduction
+ ------------
+ 
+ This is a port of the PILOT-XFER tools from SMS/QDOS.
+ 
+ These programs allow you to backup, restore, install and transfer data 
+ to and from a Palm Pilot (all models, Palm III tested), between your
+ Palm computer and an SMS/QDOS system.
+ 
+ Please see the original pilot-xfer documentation (in this archive) for 
+ more details. In many cases the documentation is the source code.
+ 
+ Quick Start
+ -----------
+ 
+ setenv "PILOTPORT=ser1hr" : REM use serial 1 to talk to the pilot
+ setenv "PILOTRATE=19200"  : At 19200 baud (the Palm supports to 57600)
+                           : Possibly your QDOS system doesn't
+ 
+ ex 'pilot-xfer';'-l' : REM QDOS is brain dead and thinks I'm trying 
+                      : REM to subtract! Run pilot-xfer, dumbo.
+ 
+ ex 'install-memo';'ser2 README.QDOS' : Install README as a Palm Memo
+ 
+ 
+ Distribution
+ ------------
+ 
+ This archive includes all original source code plus the QDOS patches
+ (qplink.pat). To rebuild, use patch to, er, patch the original source
+ code and rebuild with c68. Enjoy.
+ 
+ Ported by
+ ---------
+ 
+ jonathan.hudson@jrhudson.demon.co.uk				1/3/99
diff -r -w -b -N -c /opt/src/pilot-link/addresses.c ./addresses.c
*** /opt/src/pilot-link/addresses.c	Thu Sep 11 19:06:41 1997
--- ./addresses.c	Sun Feb 28 19:40:12 1999
***************
*** 14,19 ****
--- 14,22 ----
  #include "pi-address.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "addresses";
+ #endif
                    
  int main(int argc, char *argv[])
  {
***************
*** 23,30 ****
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
    struct AddressAppInfo aai;
  
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
--- 26,35 ----
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer = 0;
    struct AddressAppInfo aai;
+   buffer = malloc(0xffff);
+   if(!buffer) exit(2);
    
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/debugsh.c ./debugsh.c
*** /opt/src/pilot-link/debugsh.c	Thu Sep 11 19:07:10 1997
--- ./debugsh.c	Sun Feb 28 19:40:58 1999
***************
*** 18,23 ****
--- 18,26 ----
  #ifdef HAVE_SYS_SELECT_H
  #include <sys/select.h>
  #endif
+ #ifdef QDOS
+ char _prog_name[] = "debugsh";
+ #endif
  
  int done = 0;
  
diff -r -w -b -N -c /opt/src/pilot-link/dlpsh.c ./dlpsh.c
*** /opt/src/pilot-link/dlpsh.c	Thu Sep 11 19:08:09 1997
--- ./dlpsh.c	Sun Feb 28 19:41:14 1999
***************
*** 10,15 ****
--- 10,18 ----
  
  #define TICKLE_INTERVAL 7
  
+ #ifdef QDOS
+ char _prog_name[] = "dlpsh";
+ #endif
  
  int socket_descriptor;
  struct pi_socket *ticklish_pi_socket;
diff -r -w -b -N -c /opt/src/pilot-link/include/pi-config.h ./include/pi-config.h
*** /opt/src/pilot-link/include/pi-config.h	Wed Feb  3 22:22:02 1999
--- ./include/pi-config.h	Sun Feb 28 12:03:57 1999
***************
*** 35,52 ****
  /* Define if you have the dup2 function.  */
  #define HAVE_DUP2 1
  
- /* Define if you have the cfmakeraw function. */
- #define HAVE_CFMAKERAW 1
- 
- /* Define if you have the cfsetspeed function. */
- #define HAVE_CFSETSPEED 1
- 
- /* Define if you have the cfsetispeed function. */
- #define HAVE_CFSETISPEED 1
- 
- /* Define if you have the cfsetospeed function. */
- #define HAVE_CFSETOSPEED 1
- 
  /* Define if you have the sigaction function. */
  #define HAVE_SIGACTION 1
  
--- 35,40 ----
***************
*** 56,64 ****
  /* Define if you have the setenv function. */
  #define HAVE_SETENV 1
  
- /* Define if you have the cispeed and cospeed members of struct termios */
- #define TERMIOS_CSPEED 1
- 
  /* Define if you have the sa_len member of struct sockaddr */
  /* #undef HAVE_SA_LEN */
  
--- 44,49 ----
***************
*** 68,97 ****
  /* Define if you have the gethostname function */
  #define HAVE_GETHOSTNAME 1
  
- /* Define if you have the uname function */
- #define HAVE_UNAME 1
- 
  /* Define if you have the <fcntl.h> header file.  */
  #define HAVE_FCNTL_H 1
  
- /* Define if you have the <malloc.h> header file.  */
- #define HAVE_MALLOC_H 1
- 
- /* Define if you have the <memory.h> header file.  */
- #define HAVE_MEMORY_H 1
- 
  /* Define if you have the <string.h> header file.  */
  #define HAVE_STRING_H 1
  
- /* Define if you have the <strings.h> header file.  */
- #define HAVE_STRINGS_H 1
- 
- /* Define if you have the <stdlib.h> header file.  */
- #define HAVE_STDLIB_H 1
- 
- /* Define if you have the <sys/ioctl.h> header file.  */
- #define HAVE_SYS_IOCTL_H 1
- 
  /* Define if you have the <sys/select.h> header file.  */
  #define HAVE_SYS_SELECT_H 1
  
--- 53,64 ----
***************
*** 125,132 ****
  /* Define if you have the <netdb.h> header file.  */
  #define HAVE_NETDB_H 1
  
! /* Define if you have the <sys/utsname.h> header file.  */
! #define HAVE_SYS_UTSNAME_H 1
  
  #ifdef NeXT
  # include <libc.h>
--- 92,105 ----
  /* Define if you have the <netdb.h> header file.  */
  #define HAVE_NETDB_H 1
  
! #define HAVE_STDLIB_H 1
! 
! #ifdef QDOS
! #include <sys/bsdtypes.h>
! #define strcasecmp stricmp
! #define strncasecmp strnicmp
! #define setenv putenv
! #endif
  
  #ifdef NeXT
  # include <libc.h>
diff -r -w -b -N -c /opt/src/pilot-link/include/pi-macros.h ./include/pi-macros.h
*** /opt/src/pilot-link/include/pi-macros.h	Sun Jul 13 00:36:48 1997
--- ./include/pi-macros.h	Sun Feb 28 13:24:49 1999
***************
*** 18,24 ****
  #endif
  
  #ifndef __cplusplus
! 
  #define get_long(ptr) ((unsigned long)\
                         ((((unsigned char*)(ptr))[0] << 24) | \
                         (((unsigned char*)(ptr))[1] << 16) | \
--- 18,24 ----
  #endif
  
  #ifndef __cplusplus
! #if 1 /*ndef QDOS*/
  #define get_long(ptr) ((unsigned long)\
                         ((((unsigned char*)(ptr))[0] << 24) | \
                         (((unsigned char*)(ptr))[1] << 16) | \
***************
*** 99,105 ****
--- 99,187 ----
                             )))
  
  #define char4(c1,c2,c3,c4) (((c1)<<24)|((c2)<<16)|((c3)<<8)|(c4))
+ #else
+ /*****************************************************************************/
+ #define char4(c1,c2,c3,c4) (((c4)<<24)|((c3)<<16)|((c2)<<8)|(c1))
+ #define get_long(ptr) ((unsigned long)\
+                        ((((unsigned char*)(ptr))[3] << 24) | \
+                        (((unsigned char*)(ptr))[2] << 16) | \
+                        (((unsigned char*)(ptr))[1] << 8)  | \
+                        (((unsigned char*)(ptr))[0])))
+ 
+ #define get_treble(ptr) ((unsigned long)\
+                         ((((unsigned char*)(ptr))[3] << 16) | \
+                          (((unsigned char*)(ptr))[2] << 8)  | \
+                          (((unsigned char*)(ptr))[1])))
+                        
+ #define get_short(ptr) ((unsigned short)\
+                        ((((unsigned char*)(ptr))[1] << 8)  | \
+                         (((unsigned char*)(ptr))[0])))
+                         
+ #define get_byte(ptr) (((unsigned char*)(ptr))[0])
+ 
+ #define get_slong(ptr) (signed long)(\
+ 				(get_long((ptr)) > 0x7FFFFFFF) ?\
+                                 (((signed long)(get_long((ptr)) & 0x7FFFFFFF)) - 0x80000000):\
+                                 ((signed long)(get_long((ptr))))\
+                                 )
  
+ #define get_streble(ptr) (signed long)(\
+ 				(get_treble((ptr)) > 0x7FFFFF) ?\
+                                 (((signed long)(get_treble((ptr)) & 0x7FFFFF)) - 0x800000):\
+                                 ((signed long)(get_treble((ptr))))\
+                                 )
+ 
+ #define get_sshort(ptr) (signed short)(\
+ 				(get_short((ptr)) > 0x7FFF) ?\
+                                 (((signed short)(get_short((ptr)) & 0x7FFF)) - 0x8000):\
+                                 ((signed short)(get_short((ptr))))\
+                                 )
+ 
+ #define get_sbyte(ptr) (signed char)(\
+ 				(get_byte((ptr)) > 0x7F) ?\
+                                 (((signed char)(get_byte((ptr)) & 0x7F)) - 0x80):\
+                                 ((signed char)(get_byte((ptr))))\
+                                 )
+ 
+ #define set_long(ptr,val) ((((unsigned char*)(ptr))[3] = (((unsigned long)(val)) >> 24) & 0xff), \
+ 		          (((unsigned char*)(ptr))[2] = (((unsigned long)(val)) >> 16) & 0xff), \
+ 		          (((unsigned char*)(ptr))[1] = (((unsigned long)(val)) >> 8) & 0xff), \
+ 		          (((unsigned char*)(ptr))[0] = (((unsigned long)(val)) >> 0) & 0xff))
+ 
+ #define set_slong(ptr,val) set_long((ptr),((unsigned long)(\
+                             (((signed long)(val)) < 0) ?\
+                             ((unsigned long)(((signed long)(val)) + 0x80000000) | 0x80000000) :\
+                             (val)\
+                            )))
+ 
+ #define set_treble(ptr,val) ((((unsigned char*)(ptr))[3] = (((unsigned long)(val)) >> 16) & 0xff), \
+ 		             (((unsigned char*)(ptr))[2] = (((unsigned long)(val)) >> 8) & 0xff), \
+ 		             (((unsigned char*)(ptr))[1] = (((unsigned long)(val)) >> 0) & 0xff))
+ 
+ #define set_streble(ptr,val) set_treble((ptr),((unsigned long)(\
+                             (((signed long)(val)) < 0) ?\
+                             ((unsigned long)(((signed long)(val)) + 0x800000) | 0x800000) :\
+                             (val)\
+                            )))
+                        
+ #define set_short(ptr,val) ((((unsigned char*)(ptr))[1] = (((unsigned short)(val)) >> 8) & 0xff), \
+ 		            (((unsigned char*)(ptr))[0] = (((unsigned short)(val)) >> 0) & 0xff))
+ 
+ #define set_sshort(ptr,val) set_short((ptr),((unsigned short)(\
+                             (((signed short)(val)) < 0) ?\
+                             ((unsigned short)(((signed short)(val)) + 0x8000) | 0x8000) :\
+                             (val)\
+                            )))
+ 
+ #define set_byte(ptr,val) (((unsigned char*)(ptr))[0]=(val))
+ 
+ #define set_sbyte(ptr,val) set_byte((ptr),((unsigned char)(\
+                             (((signed char)(val)) < 0) ?\
+                             ((unsigned char)(((signed char)(val)) + 0x80) | 0x80) :\
+                             (val)\
+                            )))
+ /*****************************************************************************/
+ #endif
  #else /*ifdef __cplusplus*/
  
  inline unsigned long get_long(const void *buf) 
diff -r -w -b -N -c /opt/src/pilot-link/install-datebook.c ./install-datebook.c
*** /opt/src/pilot-link/install-datebook.c	Fri Aug  8 04:09:02 1997
--- ./install-datebook.c	Sun Feb 28 19:36:41 1999
***************
*** 14,19 ****
--- 14,23 ----
  #include "pi-dlp.h"
  #include "pi-datebook.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "install-datebook";
+ #endif
+ 
  extern time_t parsedate(char * p);
  
  int main(int argc, char *argv[])
***************
*** 23,29 ****
    int sd;
    int i;
    int Appointment_size;
!   unsigned char Appointment_buf[0xffff];
    struct Appointment appointment;
    FILE *f;
    struct PilotUser U;
--- 27,33 ----
    int sd;
    int i;
    int Appointment_size;
!   unsigned char *Appointment_buf;
    struct Appointment appointment;
    FILE *f;
    struct PilotUser U;
***************
*** 33,38 ****
--- 37,45 ----
    char *file_text;
    char *fields[4];
    int fieldno;
+ 
+   if(!(Appointment_buf = malloc(0xffff)))
+       exit(2);
  
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s file [file] ...\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/install-memo.c ./install-memo.c
*** /opt/src/pilot-link/install-memo.c	Thu Sep 11 18:58:31 1997
--- ./install-memo.c	Sun Feb 28 19:35:54 1999
***************
*** 10,15 ****
--- 10,18 ----
  #include "pi-socket.h"
  #include "pi-dlp.h"
  #include "pi-memo.h"
+ #ifdef QDOS
+ char _prog_name[] = "install-memo";
+ #endif
  
  int main(int argc, char *argv[])
  {
***************
*** 23,31 ****
    FILE *f;
    struct PilotUser U;
    int ret;
!   char buf[0xffff];
    int category;
    struct MemoAppInfo mai;
  
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s [-c category] file [file] ...\n",argv[0],TTYPrompt);
--- 26,36 ----
    FILE *f;
    struct PilotUser U;
    int ret;
!   char *buf;
    int category;
    struct MemoAppInfo mai;
+   if(!(buf = malloc(0xffff)))
+       exit(2);
  
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s [-c category] file [file] ...\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/install-todos.c ./install-todos.c
*** /opt/src/pilot-link/install-todos.c	Thu Sep 11 18:58:40 1997
--- ./install-todos.c	Sun Feb 28 19:37:09 1999
***************
*** 13,18 ****
--- 13,22 ----
  #include "pi-dlp.h"
  #include "pi-todo.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "install-todos";
+ #endif
+ 
  int main(int argc, char *argv[])
  {
    struct pi_sockaddr addr;
***************
*** 20,26 ****
    int sd;
    int i;
    int ToDo_size;
!   unsigned char ToDo_buf[0xffff];
    struct ToDo todo;
    FILE *f;
    struct PilotUser U;
--- 24,30 ----
    int sd;
    int i;
    int ToDo_size;
!   unsigned char *ToDo_buf=0;
    struct ToDo todo;
    FILE *f;
    struct PilotUser U;
***************
*** 33,38 ****
--- 37,45 ----
    int cLen;
    int count;
  
+   ToDo_buf = malloc(0xffff);
+   if(!ToDo_buf) exit(2);
+   
  #ifndef NOTHAPPENING
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s file [file] ...\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/install-user.c ./install-user.c
*** /opt/src/pilot-link/install-user.c	Sat Aug 16 05:23:54 1997
--- ./install-user.c	Sun Feb 28 19:36:17 1999
***************
*** 18,23 ****
--- 18,27 ----
  #include "pi-socket.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "install-user";
+ #endif
+ 
  int main(int argc, char *argv[])
  {
    struct pi_sockaddr addr;
diff -r -w -b -N -c /opt/src/pilot-link/libsock/Makefile.qdos ./libsock/Makefile.qdos
*** /opt/src/pilot-link/libsock/Makefile.qdos	Thu Jan  1 01:00:00 1970
--- ./libsock/Makefile.qdos	Sun Feb 28 11:01:11 1999
***************
*** 0 ****
--- 1,128 ----
+ # Generated automatically from Makefile.in by configure.
+ 
+ O = o
+ 
+ SOCKOBJS = socket.$(O) serial.$(O) slp.$(O) padp.$(O) \
+        dlp.$(O) cmp.$(O) syspkt.$(O) inetserial.o inet.o
+ 
+ FILEOBJS = pi-file.$(O)
+ 
+ APPOBJS = datebook.$(O) memo.$(O) address.$(O) todo.$(O) expense.$(O) mail.$(O) sync.$(O) appinfo.$(O)
+ 
+ UTILOBJS = utils.$(O)
+ 
+ SERIAL = qdosserial.$(O)
+ 
+ OBJS = $(SOCKOBJS) $(FILEOBJS) $(APPOBJS) $(UTILOBJS) $(SERIAL)
+ 
+ prefix = .
+ exec_prefix = .
+ libdir = .
+ srcdir = .
+ 
+ top_builddir = ..
+ 
+ CC = qcc
+ CFLAGS = -I../include -I$(srcdir)/../include -O
+ # -DPADP_TRACE
+ # -DDEBUG
+ # -DNO_DLP_TRACE
+ # -DNO_SERIAL_TRACE
+ AR = ar
+ ARFLAGS = cur
+ RANLIB = ranlib
+ RM = rm -f
+ 
+ .SUFFIXES: .c .o
+ 
+ .c.o:
+ 	$(CC) $(CFLAGS) -c $<
+ 
+ all: libpisock.a
+ 
+ libpisock.a: $(OBJS)
+ 	$(RM) libpisock.a
+ 	slb -v -Lslb.tmp $(OBJS)
+ 	tsort slb.tmp >slb.list
+ 	slb -crv -mslb.list libpisock.a
+ 	rm -f slb.tmp slb.list
+ 
+ clean:
+ 	$(RM) *.o *.lo *.a *.la core a.out *.orig
+ 	$(RM) -rf .libs _libs
+ 
+ depend:
+ 	perl -i~ -ne 'print if 1../^#Depend/' Makefile.in ; gcc -w -MM -I../include *.c | perl -pne 's/^(\S*)\.o/$$& $$1.lo/g' >> Makefile.in
+ 
+ #Dependencies
+ address.o address.lo: address.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-address.h ../include/pi-appinfo.h
+ appinfo.o appinfo.lo: appinfo.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-appinfo.h
+ cmp.o cmp.lo: cmp.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-padp.h ../include/pi-cmp.h ../include/pi-serial.h
+ datebook.o datebook.lo: datebook.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-datebook.h ../include/pi-appinfo.h
+ dlp.o dlp.lo: dlp.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-syspkt.h
+ expense.o expense.lo: expense.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-expense.h ../include/pi-appinfo.h
+ inet.o inet.lo: inet.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-inet.h ../include/pi-slp.h ../include/pi-syspkt.h \
+  ../include/pi-padp.h ../include/pi-dlp.h
+ inetserial.o inetserial.lo: inetserial.c ../include/pi-source.h \
+  ../include/pi-config.h ../include/pi-socket.h ../include/pi-args.h \
+  ../include/pi-macros.h ../include/pi-serial.h \
+  ../include/pi-inetserial.h ../include/pi-slp.h ../include/pi-syspkt.h \
+  ../include/pi-padp.h
+ mail.o mail.lo: mail.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-mail.h ../include/pi-appinfo.h
+ memo.o memo.lo: memo.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-memo.h ../include/pi-appinfo.h
+ os2serial.o os2serial.lo: os2serial.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-serial.h ../include/pi-slp.h ../include/pi-syspkt.h \
+  ../include/pi-padp.h
+ padp.o padp.lo: padp.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-padp.h ../include/pi-slp.h ../include/pi-serial.h
+ pi-file.o pi-file.lo: pi-file.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-file.h ../include/pi-dlp.h
+ serial.o serial.lo: serial.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-serial.h ../include/pi-inetserial.h \
+  ../include/pi-padp.h ../include/pi-cmp.h ../include/pi-dlp.h \
+  ../include/pi-syspkt.h
+ slp.o slp.lo: slp.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-slp.h
+ socket.o socket.lo: socket.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-serial.h ../include/pi-inetserial.h \
+  ../include/pi-inet.h ../include/pi-padp.h ../include/pi-cmp.h \
+  ../include/pi-dlp.h ../include/pi-syspkt.h
+ sync.o sync.lo: sync.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-sync.h
+ syspkt.o syspkt.lo: syspkt.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-syspkt.h ../include/pi-slp.h ../include/pi-serial.h
+ todo.o todo.lo: todo.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h \
+  ../include/pi-dlp.h ../include/pi-todo.h ../include/pi-appinfo.h
+ unixserial.o unixserial.lo: unixserial.c ../include/pi-source.h \
+  ../include/pi-config.h ../include/pi-socket.h ../include/pi-args.h \
+  ../include/pi-macros.h ../include/pi-serial.h ../include/pi-slp.h \
+  ../include/pi-syspkt.h ../include/pi-padp.h
+ utils.o utils.lo: utils.c ../include/pi-source.h ../include/pi-config.h \
+  ../include/pi-socket.h ../include/pi-args.h ../include/pi-macros.h
diff -r -w -b -N -c /opt/src/pilot-link/libsock/datebook.c ./libsock/datebook.c
*** /opt/src/pilot-link/libsock/datebook.c	Thu Sep 11 19:20:55 1997
--- ./libsock/datebook.c	Sun Feb 28 10:36:18 1999
***************
*** 182,196 ****
  
  	if (iflags & descFlag)
  	{
! 		a->description = strdup(p2);
! 		p2 += strlen(p2) + 1;
  	} else
  		a->description = 0;
  
  	if (iflags & noteFlag)
  	{
! 		a->note = strdup(p2);
! 		p2 += strlen(p2) + 1;
  	}
  	else {
  		a->note = 0;
--- 182,196 ----
  
  	if (iflags & descFlag)
  	{
! 		a->description = strdup((char*)p2);
! 		p2 += strlen((char *)p2) + 1;
  	} else
  		a->description = 0;
  
  	if (iflags & noteFlag)
  	{
! 		a->note = strdup((char *)p2);
! 		p2 += strlen((char*)p2) + 1;
  	}
  	else {
  		a->note = 0;
diff -r -w -b -N -c /opt/src/pilot-link/libsock/dlp.c ./libsock/dlp.c
*** /opt/src/pilot-link/libsock/dlp.c	Sat Aug 16 05:25:43 1997
--- ./libsock/dlp.c	Sun Feb 28 15:40:30 1999
***************
*** 681,691 ****
      fprintf(stderr, " Wrote: Handle: %d\n", dbhandle);
    }
  #endif
-   
    result = dlp_exec(sd, 0x19, 0x20, &handle, 1, 0, 0);
- 
    Expect(0);
-   
    return result;
  }
  
--- 681,688 ----
diff -r -w -b -N -c /opt/src/pilot-link/libsock/expense.c ./libsock/expense.c
*** /opt/src/pilot-link/libsock/expense.c	Thu Sep 11 19:26:09 1997
--- ./libsock/expense.c	Sun Feb 28 10:35:58 1999
***************
*** 70,76 ****
      return 0;
    
    if (*buffer) {
!     a->amount = strdup(buffer);
      buffer += strlen(a->amount);
      len -= strlen(a->amount);
    } else {
--- 70,76 ----
      return 0;
    
    if (*buffer) {
!     a->amount = strdup((char*)buffer);
      buffer += strlen(a->amount);
      len -= strlen(a->amount);
    } else {
***************
*** 83,89 ****
      return 0;
  
    if (*buffer) {
!     a->vendor = strdup(buffer);
      buffer += strlen(a->vendor);
      len -= strlen(a->vendor);
    } else {
--- 83,89 ----
      return 0;
  
    if (*buffer) {
!     a->vendor = strdup((char*)buffer);
      buffer += strlen(a->vendor);
      len -= strlen(a->vendor);
    } else {
***************
*** 96,102 ****
      return 0;
  
    if (*buffer) {
!     a->city = strdup(buffer);
      buffer += strlen(a->city);
      len -= strlen(a->city);
    } else {
--- 96,102 ----
      return 0;
  
    if (*buffer) {
!     a->city = strdup((char *)buffer);
      buffer += strlen(a->city);
      len -= strlen(a->city);
    } else {
***************
*** 109,115 ****
      return 0;
  
    if (*buffer) {
!     a->attendees = strdup(buffer);
      buffer += strlen(a->attendees);
      len -= strlen(a->attendees);
    } else {
--- 109,115 ----
      return 0;
  
    if (*buffer) {
!     a->attendees = strdup((char *)buffer);
      buffer += strlen(a->attendees);
      len -= strlen(a->attendees);
    } else {
***************
*** 122,128 ****
      return 0;
  
    if (*buffer) {
!     a->note = strdup(buffer);
      buffer += strlen(a->note);
      len -= strlen(a->note);
    } else {
--- 122,128 ----
      return 0;
  
    if (*buffer) {
!     a->note = strdup((char *)buffer);
      buffer += strlen(a->note);
      len -= strlen(a->note);
    } else {
***************
*** 167,206 ****
    buf += 4;
    
    if (a->amount) {
!     strcpy(buf, a->amount);
!     buf += strlen(buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
  
    if (a->vendor) {
!     strcpy(buf, a->vendor);
!     buf += strlen(buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->city) {
!     strcpy(buf, a->city);
!     buf += strlen(buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->attendees) {
!     strcpy(buf, a->attendees);
!     buf += strlen(buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->note) {
!     strcpy(buf, a->note);
!     buf += strlen(buf);
    } else {
      set_byte(buf, 0);
    }
--- 167,206 ----
    buf += 4;
    
    if (a->amount) {
!     strcpy((char *)buf, a->amount);
!     buf += strlen((char *)buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
  
    if (a->vendor) {
!     strcpy((char *)buf, a->vendor);
!     buf += strlen((char *)buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->city) {
!     strcpy((char *)buf, a->city);
!     buf += strlen((char *)buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->attendees) {
!     strcpy((char *)buf, a->attendees);
!     buf += strlen((char *)buf);
    } else {
      set_byte(buf, 0);
    }
    buf++;
    
    if (a->note) {
!     strcpy((char *)buf, a->note);
!     buf += strlen((char *)buf);
    } else {
      set_byte(buf, 0);
    }
diff -r -w -b -N -c /opt/src/pilot-link/libsock/inet.c ./libsock/inet.c
*** /opt/src/pilot-link/libsock/inet.c	Tue Aug  5 21:36:22 1997
--- ./libsock/inet.c	Sun Feb 28 11:00:53 1999
***************
*** 4,10 ****
   * This is free software, licensed under the GNU Public License V2.
   * See the file COPYING for details.
   */
! 
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <netinet/in.h>
--- 4,12 ----
   * This is free software, licensed under the GNU Public License V2.
   * See the file COPYING for details.
   */
! #ifdef QDOS
! #include <sys/bsdtypes.h>
! #endif
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <netinet/in.h>
***************
*** 30,238 ****
  
  int pi_inet_connect(struct pi_socket *ps, struct sockaddr *addr, int addrlen)
  {
-   struct sockaddr_in serv_addr;
-   char msg1[22] = "\x90\x01\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x08\x01\x00\x00\x00\x00\x00\x00\x00";
-   char msg2[50] = 
- "\x92\x01\x00\x00\x00\x00\x00\x00\x00\x20\
- \x00\x00\x00\x24\xff\xff\xff\xff\x00\x3c\x00\x3c\x40\x00\x00\x00\
- \x01\x00\x00\x00\xc0\xa8\xa5\x1e\x04\x01\x00\x00\x00\x00\x00\x00\
- \x00\x00\x00\x00\x00\x00\x00\x00";
-   char msg3[8] = "\x93\x00\x00\x00\x00\x00\x00\x00";
-   char buffer[200];
- 
-   ps->mac->fd = socket(AF_INET, SOCK_STREAM, 0);
- 
-   if (ps->sd) {
-     int orig = ps->mac->fd;
- #ifdef HAVE_DUP2
-     ps->mac->fd = dup2(ps->mac->fd, ps->sd);
- #else
- #ifdef F_DUPFD
-     close(ps->sd);
-     ps->mac->fd = fcntl(ps->mac->fd, F_DUPFD, ps->sd);
- #else
-     close(ps->sd);
-     ps->mac->fd = dup(ps->mac->fd); /* Unreliable */
- #endif
- #endif
-     if (ps->mac->fd != orig)
-       close(orig);
-   }
- 
-   if (addr->sa_family == AF_INET) {
-     memcpy(&serv_addr, addr, addrlen);
-   } else {
-     struct pi_sockaddr * paddr = (struct pi_sockaddr*)addr;
-     char * device = paddr->pi_device+1;
-     memset(&serv_addr, 0, sizeof(serv_addr));
-     serv_addr.sin_family = AF_INET;
-     serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
-     serv_addr.sin_port = htons(14238);
-     if (strlen(device)>1) {
-       if ((serv_addr.sin_addr.s_addr = inet_addr(device))==-1) {
-         struct hostent * hostent = gethostbyname(device);
-         if (!hostent) {
-           fprintf(stderr, "Unable to resolve host '%s'", device);
            return -1;
          }
-         memcpy((char*)&serv_addr.sin_addr.s_addr, hostent->h_addr,hostent->h_length);
-       }
-     }
-   }
-   
- 
-   if (connect(ps->mac->fd, (struct sockaddr*)&serv_addr, sizeof(serv_addr))<0)
-     return -1;
- 
-   ps->socket_listen = pi_net_listen;
-   ps->socket_accept = pi_net_accept;
-   ps->socket_send = pi_net_send;
-   ps->socket_recv = pi_net_recv;
-   ps->socket_tickle= pi_net_tickle;
-   ps->socket_close = pi_net_close;
- 
-   ps->initiator = 1;
- 
-   pi_net_send(ps, msg1, 22, 0);
-   pi_net_recv(ps, buffer, 200, 0);
-   pi_net_send(ps, msg2, 50, 0);
-   pi_net_recv(ps, buffer, 200, 0);
-   pi_net_send(ps, msg3, 8, 0);
- 
- #ifndef NO_SERIAL_TRACE
-   if(ps->debuglog) {
-     ps->debugfd = open(ps->debuglog,O_WRONLY|O_CREAT|O_APPEND,0666);
-     /* This sequence is magic used by my trace analyzer - kja */
-     write(ps->debugfd, "\0\2\0\0\0\0\0\0\0\0", 10);
-   }
- #endif
-   
-   return 0;
- }
  
  /* Bind address to a local socket */
  
  int pi_inet_bind(struct pi_socket *ps, struct sockaddr *addr, int addrlen)
  {
-   int opt, optlen;
-   struct sockaddr_in serv_addr;
-   ps->mac->fd = socket(AF_INET, SOCK_STREAM, 0);
- 
-   if (ps->sd) {
-     int orig = ps->mac->fd;
- #ifdef HAVE_DUP2
-     ps->mac->fd = dup2(ps->mac->fd, ps->sd);
- #else
- #ifdef F_DUPFD
-     close(ps->sd);
-     ps->mac->fd = fcntl(ps->mac->fd, F_DUPFD, ps->sd);
- #else
-     close(ps->sd);
-     ps->mac->fd = dup(ps->mac->fd); /* Unreliable */
- #endif
- #endif
-     if (ps->mac->fd != orig)
-       close(orig);
-     else {
-       puts("Unable to duplicate socket");
-       exit(1);
-     }
-   }
- 
-   if (addr->sa_family == AF_INET) {
-     memcpy(&serv_addr, addr, addrlen);
-   } else {
-     struct pi_sockaddr * paddr = (struct pi_sockaddr*)addr;
-     char * device = paddr->pi_device+1;
-     memset(&serv_addr, 0, sizeof(serv_addr));
-     serv_addr.sin_family = AF_INET;
-     serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
-     serv_addr.sin_port = htons(14238);
-     if (strlen(device)>1) {
-       if ((serv_addr.sin_addr.s_addr = inet_addr(device))==-1) {
-         struct hostent * hostent = gethostbyname(device);
-         if (!hostent) {
-           fprintf(stderr, "Unable to resolve host '%s'", device);
-           return -1;
-         }
-         memcpy((char*)&serv_addr.sin_addr.s_addr, hostent->h_addr,hostent->h_length);
-       }
-     }
-   }
- 
-   opt=1;
-   optlen=sizeof(opt);
-   if (setsockopt(ps->sd, SOL_SOCKET, SO_REUSEADDR, &opt, optlen)<0) {
-     return -1;
-   }
- 
-   if (bind(ps->sd, (struct sockaddr*)&serv_addr, sizeof(serv_addr))<0)
      return -1;
- 
- #ifndef NO_SERIAL_TRACE
-   if(ps->debuglog) {
-     ps->debugfd = open(ps->debuglog,O_WRONLY|O_CREAT|O_APPEND,0666);
-     /* This sequence is magic used by my trace analyzer - kja */
-     write(ps->debugfd, "\0\2\0\0\0\0\0\0\0\0", 10);
-   }
- #endif
- 
-   ps->socket_listen = pi_net_listen;
-   ps->socket_accept = pi_net_accept;
-   ps->socket_send = pi_net_send;
-   ps->socket_recv = pi_net_recv;
-   ps->socket_tickle= pi_net_tickle;
-   ps->socket_close = pi_net_close;
- 
-   ps->initiator = 0;
- 
-   return 0;
  }
  
  /* Wait for an incoming connection */
  
  static int pi_net_listen(struct pi_socket *ps, int backlog)
  {
!   return listen(ps->sd, backlog);
  }
  
  /* Accept an incoming connection */
  
  static int pi_net_accept(struct pi_socket *ps, struct sockaddr *addr, int *addrlen)
  {
-   struct pi_socket *a;
-   char msg1[50] = 
- "\x12\x01\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x24\xff\xff\
- \xff\xff\x3c\x00\x3c\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc0\xa8\
- \xa5\x1f\x04\x27\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\
- \x00\x00";
-   char msg2[46] =
- "\x13\x01\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x20\xff\xff\
- \xff\xff\x00\x3c\x00\x3c\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\
- \x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
-   char buffer[200];
- 
-   a = malloc(sizeof(struct pi_socket));
-   memcpy(a, ps, sizeof(struct pi_socket));
-   
- 
-   a->sd = accept(ps->sd, addr, addrlen);
-   if (a->sd < 0)
-     goto fail;
- 
-   pi_net_recv(a, buffer, 200, 0);
-   pi_net_send(a, msg1, 50, 0);
-   pi_net_recv(a, buffer, 200, 0);
-   pi_net_send(a, msg2, 46, 0);
-   pi_net_recv(a, buffer, 200, 0);
- 
-   pi_socket_recognize(a);
-   
-   a->connected = 1;
- 
-   return a->sd;
- fail:
-   free(a);
    return -1;
  }
  
--- 32,58 ----
  
  int pi_inet_connect(struct pi_socket *ps, struct sockaddr *addr, int addrlen)
  {
      return -1;
  }
  
  /* Bind address to a local socket */
  
  int pi_inet_bind(struct pi_socket *ps, struct sockaddr *addr, int addrlen)
  {
      return -1;
  }
  
  /* Wait for an incoming connection */
  
  static int pi_net_listen(struct pi_socket *ps, int backlog)
  {
!   return -1;
  }
  
  /* Accept an incoming connection */
  
  static int pi_net_accept(struct pi_socket *ps, struct sockaddr *addr, int *addrlen)
  {
    return -1;
  }
  
***************
*** 240,343 ****
  
  static int pi_net_send(struct pi_socket *ps, void *msg, int len, unsigned int flags)
  {
!   int n,l;
!   unsigned char buf[6];
!   buf[0] = 1;
!   buf[1] = ps->xid;
!   set_long(buf+2, len);
!   
!   l = 0;
!   while (l<6) {
!     n = write(ps->sd, buf+l, 6-l);
!     if (n>0)
!       l += n;
!     if (n<0)
!       return n;
!   }
!   
!   l = 0;
!   while (l<len) {
!     n = write(ps->sd, (char *)msg+l, len-l);
!     if (n>0)
!       l += n;
!     if (n<0)
!       return n;
!   }
! 
! #ifndef NO_SERIAL_TRACE
!   if (ps->debuglog) {
!     buf[0] = 4;
!     buf[1] = 0;
!     set_long(buf+2, len);
!     write(ps->debugfd, buf, 6);
!     write(ps->debugfd, msg, len);
!   }
! #endif
!   
!   return len;
  }
  
  /* Recv msg on a connected socket */
  
  static int pi_net_recv(struct pi_socket *ps, void *msg, int len, unsigned int flags)
  {
!   int n,l;
!   int rlen;
!   unsigned char buf[6];
!   
!   l = 0;
!   while (l<6) {
!     n = read(ps->sd, buf+l, 6-l);
!     if (n>0)
!       l += n;
!     if (n<0)
!       return n;
!   }
!   
!   rlen = get_long(buf+2);
!   
!   if (len>rlen)
!     len=rlen;
!   
!   l = 0;
!   while (l<len) {
!     n = read(ps->sd, (char *)msg+l, len-l);
!     if (n>0)
!       l += n;
!     if (n<0)
!       return n;
!   }
! 
!   if (l<rlen) {
!     char discard;
!     while (l<rlen) {
!       n = read(ps->sd, &discard, 1);
!       if (n>0)
!         l += n;
!       if (n<0)
!         return n;
!     }
!   }
! 
!   if (ps->initiator)
!     ps->xid = buf[1];
!   else {
!     ps->xid++;
!     if (ps->xid == 0xff)
!       ps->xid = 1;
!   }
! 
! #ifndef NO_SERIAL_TRACE
!   if (ps->debuglog) {
!     buf[0] = 3;
!     buf[1] = 0;
!     set_long(buf+2, len);
!     write(ps->debugfd, buf, 6);
!     write(ps->debugfd, msg, len);
!   }
! #endif
!   
!   return len;
  }
  
  static int pi_net_tickle(struct pi_socket *ps)
--- 60,73 ----
  
  static int pi_net_send(struct pi_socket *ps, void *msg, int len, unsigned int flags)
  {
!   return -1;
  }
  
  /* Recv msg on a connected socket */
  
  static int pi_net_recv(struct pi_socket *ps, void *msg, int len, unsigned int flags)
  {
!   return -1;
  }
  
  static int pi_net_tickle(struct pi_socket *ps)
***************
*** 349,367 ****
  
  static int pi_net_close(struct pi_socket * ps)
  {
-   if (ps->type == PI_SOCK_STREAM) {
-     if (ps->connected & 1) /* If socket is connected */
-       if (!(ps->connected & 2)) /* And it wasn't end-of-synced */
-         dlp_EndOfSync(ps->sd, 0);  /* then end sync, with clean status */
-   }
-   
-   close(ps->sd);
- 
- #ifndef NO_SERIAL_TRACE
-   if (ps->debugfd)
-     close(ps->debugfd);
- #endif
- 
    return 0;
  }
  
--- 79,84 ----
diff -r -w -b -N -c /opt/src/pilot-link/libsock/inetserial.c ./libsock/inetserial.c
*** /opt/src/pilot-link/libsock/inetserial.c	Thu Jul 10 17:23:57 1997
--- ./libsock/inetserial.c	Sun Feb 28 10:58:25 1999
***************
*** 4,10 ****
   * This is free software, licensed under the GNU Public License V2.
   * See the file COPYING for details.
   */
! 
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <netinet/in.h>
--- 4,12 ----
   * This is free software, licensed under the GNU Public License V2.
   * See the file COPYING for details.
   */
! #ifdef QDOS
! #include <sys/bsdtypes.h>
! #endif
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <netinet/in.h>
***************
*** 30,214 ****
  
  int pi_inetserial_open(struct pi_socket *ps, struct sockaddr * addr, int addrlen)
  {
!   struct sockaddr_in serv_addr;
!   ps->mac->fd = socket(AF_INET, SOCK_STREAM, 0);
!   
!   if (addr->sa_family == AF_INET) {
!     memcpy(&serv_addr, addr, addrlen);
!   } else {
!     struct pi_sockaddr * pa = (struct pi_sockaddr*)addr;
!     memset(&serv_addr, 0, sizeof(serv_addr));
!     serv_addr.sin_family = AF_INET;
!     serv_addr.sin_addr.s_addr = inet_addr(pa->pi_device+1);
!     serv_addr.sin_port = htons(4386);
!   }
! 
!   connect(ps->mac->fd, (struct sockaddr*)&serv_addr, sizeof(serv_addr));
! 
!   if (ps->sd) {
!     int orig = ps->mac->fd;
! #ifdef HAVE_DUP2
!     ps->mac->fd = dup2(ps->mac->fd, ps->sd);
! #else
! #ifdef F_DUPFD
!     close(ps->sd);
!     ps->mac->fd = fcntl(ps->mac->fd, F_DUPFD, ps->sd);
! #else
!     close(ps->sd);
!     ps->mac->fd = dup(ps->mac->fd); /* Unreliable */
! #endif
! #endif
!     if (ps->mac->fd != orig)
!       close(orig);
!   }
! 
! #ifndef NO_SERIAL_TRACE
!   if(ps->debuglog) {
!     ps->debugfd = open(ps->debuglog,O_WRONLY|O_CREAT|O_APPEND,0666);
!     /* This sequence is magic used by my trace analyzer - kja */
!     write(ps->debugfd, "\0\1\0\0\0\0\0\0\0\0", 10);
!   }
! #endif
! 
!   ps->serial_read = n_read;
!   ps->serial_write = n_write;
!   ps->serial_close = n_close;
!   ps->serial_changebaud = n_changebaud;
! 
    return ps->mac->fd;
  }
  
  static int n_changebaud(struct pi_socket *ps)
  {
-   char buffer[20];
-   
-   set_short(buffer, 1);
-   set_short(buffer+2, 4);
-   set_long(buffer+4, ps->rate);
-   
-   write(ps->mac->fd, buffer, 8);
- 
    return 0;
  }
  
  static int n_close(struct pi_socket *ps)
  {
!   int result;
!   char buffer[4];
!   
!   set_short(buffer, 2);
!   set_short(buffer+2, 0);
! 
!   write(ps->mac->fd, buffer, 4);
! 
!   result = close(ps->mac->fd);
!   ps->mac->fd = 0;
! 
! #ifndef NO_SERIAL_TRACE
!   if (ps->debugfd)
!     close(ps->debugfd);  
! #endif
! 
!   return result;
  }
  
  static int n_write(struct pi_socket *ps)
  {
!   struct pi_skb *skb;
!   int nwrote, len;
!   char buffer[4];
! #ifndef NO_SERIAL_TRACE
!   int i;
! #endif
! 
!   if (ps->txq) {
!   
!     ps->busy++;
! 
!     skb = ps->txq;
!     ps->txq = skb->next;
!     
!     set_short(buffer, 0);
!     set_short(buffer+2, skb->len);
!     write(ps->mac->fd, buffer, 4);
!     
!     len = 0;
!     while (len<skb->len) {
!       nwrote = 0;
!       nwrote=write(ps->mac->fd,skb->data,skb->len);
!       if (nwrote<=0)
!         break; /* transmission failure */
!       len += nwrote;
!     }
! #ifndef NO_SERIAL_TRACE
!     if (ps->debuglog)
!       for (i=0;i<skb->len;i++) {
!         write(ps->debugfd, "2", 1);
!         write(ps->debugfd, skb->data+i, 1);
!       }
! #endif
!     ps->tx_bytes += skb->len;
!     free(skb);
! 
!     ps->busy--;
!     
!     return 1;
!   }
!   return 0;
  }
  
  static int n_read(struct pi_socket *ps, int timeout)
  {
!   int r;
!   unsigned char *buf;
! #ifndef NO_SERIAL_TRACE
!   int i;
! #endif
!   fd_set ready,ready2;
!   struct timeval t;
!   
!   FD_ZERO(&ready);
!   FD_SET(ps->mac->fd, &ready);
! 
!   pi_serial_flush(ps);              /* We likely want to be in sync with tx */
!   
!   if (!ps->mac->expect) slp_rx(ps);  /* let SLP know we want a packet */
! 
!   while (ps->mac->expect) {
!     buf = ps->mac->buf;
! 
!     while (ps->mac->expect) {
!       ready2 = ready;
!       t.tv_sec = timeout/10;
!       t.tv_usec = (timeout % 10) * 100000;
!       select(ps->mac->fd+1,&ready2,0,0,&t);
!       /* If data is available in time, read it */
!       if(FD_ISSET(ps->mac->fd,&ready2))
!         r = read(ps->mac->fd, buf, ps->mac->expect);
!       else
!       {
!         /* otherwise throw out any current packet and return */
! #ifdef DEBUG
!         fprintf(stderr, "Serial RX: timeout\n");
! #endif
!         ps->mac->state = ps->mac->expect = 1;
!         ps->mac->buf = ps->mac->rxb->data;
!         ps->rx_errors++;
!         return 0;
!       }
! #ifndef NO_SERIAL_TRACE
!       if (ps->debuglog)
!         for (i=0;i<r;i++) {
!           write(ps->debugfd, "1", 1);
!           write(ps->debugfd, buf+i, 1);
!         }
! #endif
!       ps->rx_bytes += r;
!       buf += r;
!       ps->mac->expect -= r;
!     }
!     slp_rx(ps);
!   }
!   return 0;
  }
  
--- 32,58 ----
  
  int pi_inetserial_open(struct pi_socket *ps, struct sockaddr * addr, int addrlen)
  {
!     ps->mac->fd = -1;
      return ps->mac->fd;
  }
  
  static int n_changebaud(struct pi_socket *ps)
  {
    return 0;
  }
  
  static int n_close(struct pi_socket *ps)
  {
!   return -1;
  }
  
  static int n_write(struct pi_socket *ps)
  {
!   return -1;
  }
  
  static int n_read(struct pi_socket *ps, int timeout)
  {
!   return -1;    
  }
  
diff -r -w -b -N -c /opt/src/pilot-link/libsock/mail.c ./libsock/mail.c
*** /opt/src/pilot-link/libsock/mail.c	Fri Aug  8 18:52:22 1997
--- ./libsock/mail.c	Sun Feb 28 12:10:34 1999
***************
*** 94,102 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->subject = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->subject = 0;
    buffer++;
--- 94,102 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->subject = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->subject = 0;
    buffer++;
***************
*** 104,112 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->from = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->from = 0;
    buffer++;
--- 104,112 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->from = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->from = 0;
    buffer++;
***************
*** 114,122 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->to = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->to = 0;
    buffer++;
--- 114,122 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->to = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->to = 0;
    buffer++;
***************
*** 124,132 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->cc = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->cc = 0;
    buffer++;
--- 124,132 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->cc = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->cc = 0;
    buffer++;
***************
*** 134,142 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->bcc = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->bcc = 0;
    buffer++;
--- 134,142 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->bcc = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->bcc = 0;
    buffer++;
***************
*** 144,152 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->replyTo = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->replyTo = 0;
    buffer++;
--- 144,152 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->replyTo = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->replyTo = 0;
    buffer++;
***************
*** 154,162 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->sentTo = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->sentTo = 0;
    buffer++;
--- 154,162 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->sentTo = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->sentTo = 0;
    buffer++;
***************
*** 164,172 ****
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->body = strdup(buffer);
!     buffer += strlen(buffer);
!     len -= strlen(buffer);
    } else
      a->body = 0;
    buffer++;
--- 164,172 ----
    if (len<1)
      return 0;
    if (get_byte(buffer)) {
!     a->body = strdup((char*)buffer);
!     buffer += strlen((char*)buffer);
!     len -= strlen((char*)buffer);
    } else
      a->body = 0;
    buffer++;
***************
*** 223,272 ****
    buffer += 6;
    
    if (a->subject) {
!     strcpy(buffer, a->subject);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->from) {
!     strcpy(buffer, a->from);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->to) {
!     strcpy(buffer, a->to);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->cc) {
!     strcpy(buffer, a->cc);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->bcc) {
!     strcpy(buffer, a->bcc);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->replyTo) {
!     strcpy(buffer, a->replyTo);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->sentTo) {
!     strcpy(buffer, a->sentTo);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->body) {
!     strcpy(buffer, a->body);
!     buffer += strlen(buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
--- 223,272 ----
    buffer += 6;
    
    if (a->subject) {
!     strcpy((char*)buffer, a->subject);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->from) {
!     strcpy((char*)buffer, a->from);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->to) {
!     strcpy((char*)buffer, a->to);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->cc) {
!     strcpy((char*)buffer, a->cc);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->bcc) {
!     strcpy((char*)buffer, a->bcc);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->replyTo) {
!     strcpy((char*)buffer, a->replyTo);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->sentTo) {
!     strcpy((char*)buffer, a->sentTo);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
    if (a->body) {
!     strcpy((char*)buffer, a->body);
!     buffer += strlen((char*)buffer);
    } else
      set_byte(buffer, 0);
    buffer++;
***************
*** 349,368 ****
    record += 2;
    
    if (get_byte(record)) {
!     a->filterTo = strdup(record);
!     record += strlen(record);
    } else
      a->filterTo = 0;
    record++;
    if (get_byte(record)) {
!     a->filterFrom = strdup(record);
!     record += strlen(record);
    } else
      a->filterFrom = 0;
    record++;
    if (get_byte(record)) {
!     a->filterSubject = strdup(record);
!     record += strlen(record);
    } else
      a->filterSubject = 0;
    record++;  
--- 349,368 ----
    record += 2;
    
    if (get_byte(record)) {
!     a->filterTo = strdup((char*)record);
!     record += strlen((char*)record);
    } else
      a->filterTo = 0;
    record++;
    if (get_byte(record)) {
!     a->filterFrom = strdup((char*)record);
!     record += strlen((char*)record);
    } else
      a->filterFrom = 0;
    record++;
    if (get_byte(record)) {
!     a->filterSubject = strdup((char*)record);
!     record += strlen((char*)record);
    } else
      a->filterSubject = 0;
    record++;  
***************
*** 394,412 ****
    set_short(record, ai->truncate); record+=2;
    
    if(ai->filterTo) {
!     strcpy(record, ai->filterTo);
      record+=strlen(ai->filterTo);
    }
    *record++ = 0;
  
    if(ai->filterFrom) {
!     strcpy(record, ai->filterFrom);
      record+=strlen(ai->filterFrom);
    }
    *record++ = 0;
  
    if(ai->filterSubject) {
!     strcpy(record, ai->filterSubject);
      record+=strlen(ai->filterSubject);
    }
    *record++ = 0;
--- 394,412 ----
    set_short(record, ai->truncate); record+=2;
    
    if(ai->filterTo) {
!     strcpy((char*)record, ai->filterTo);
      record+=strlen(ai->filterTo);
    }
    *record++ = 0;
  
    if(ai->filterFrom) {
!     strcpy((char*)record, ai->filterFrom);
      record+=strlen(ai->filterFrom);
    }
    *record++ = 0;
  
    if(ai->filterSubject) {
!     strcpy((char*)record, ai->filterSubject);
      record+=strlen(ai->filterSubject);
    }
    *record++ = 0;
***************
*** 420,426 ****
    if (len<1)
      return 0;
    
!   a->signature = strdup(record);
    
    record+= strlen(a->signature)+1;
    
--- 420,426 ----
    if (len<1)
      return 0;
    
!   a->signature = strdup((char*)record);
    
    record+= strlen(a->signature)+1;
    
***************
*** 439,445 ****
    if (len<destlen)
      return 0;
    if (ai->signature) {
!     strcpy(record, ai->signature);
      record+=strlen(ai->signature);
    }
    *record = 0;
--- 439,445 ----
    if (len<destlen)
      return 0;
    if (ai->signature) {
!     strcpy((char*)record, ai->signature);
      record+=strlen(ai->signature);
    }
    *record = 0;
diff -r -w -b -N -c /opt/src/pilot-link/libsock/pi-file.c ./libsock/pi-file.c
*** /opt/src/pilot-link/libsock/pi-file.c	Thu Sep 11 19:00:13 1997
--- ./libsock/pi-file.c	Sun Feb 28 19:31:42 1999
***************
*** 23,28 ****
--- 23,29 ----
  #include "pi-socket.h"
  #include "pi-file.h"
  
+ 
  #define pi_mktag(c1,c2,c3,c4) (((c1)<<24)|((c2)<<16)|((c3)<<8)|(c4))
  
  /*
***************
*** 524,534 ****
  {
    struct pi_file *pf;
  
!   if ((pf = calloc (1, sizeof *pf)) == NULL)
      return (NULL);
  
    if ((pf->file_name = strdup (name)) == NULL)
      goto bad;
  
    pf->for_writing = 1;
    pf->info = *info;
--- 525,538 ----
  {
    struct pi_file *pf;
  
!   if ((pf = calloc (1, sizeof (struct pi_file))) == NULL)
      return (NULL);
  
    if ((pf->file_name = strdup (name)) == NULL)
      goto bad;
+ #ifdef DEBUG
+   fprintf(stderr,"create %s\n", name);
+ #endif
    
    pf->for_writing = 1;
    pf->info = *info;
***************
*** 547,552 ****
--- 551,557 ----
    return (pf);
  
  bad:
+   fprintf(stderr, "Create fails\n");
    pi_file_free (pf);
    return (NULL);
  }
***************
*** 675,695 ****
  			   int attrs, int category, pi_uid_t uid)
  {
    struct pi_file_entry *entp;
! 
  #ifdef DEBUG
!   printf ("append: %d\n", pf->nentries);
  #endif
  
    if (!pf->for_writing || pf->resource_flag)
      return (-1);
  
    entp = pi_file_append_entry (pf);
!   
!   if (size && (fwrite (buf, size, 1, pf->tmpf) != 1)) {
      pf->err = 1;
      return (-1);
    }
- 
    entp->size = size;
    entp->attrs = (attrs & 0xf0) | (category & 0xf);
    entp->uid = uid;
--- 680,701 ----
  			   int attrs, int category, pi_uid_t uid)
  {
    struct pi_file_entry *entp;
!       int r;
  #ifdef DEBUG
!   printf ("append: %d %d\n", pf->nentries, size);
  #endif
  
    if (!pf->for_writing || pf->resource_flag)
      return (-1);
+ #ifdef DEBUG
+   printf ("append1: %d %d\n", pf->nentries, size);
+ #endif
  
    entp = pi_file_append_entry (pf);
!   if (size && ((r = fwrite (buf, size, 1, pf->tmpf)) != 1)) {
        pf->err = 1;
        return (-1);
    }
    entp->size = size;
    entp->attrs = (attrs & 0xf0) | (category & 0xf);
    entp->uid = uid;
***************
*** 800,815 ****
  {
    int db;
    int l,j;
!   unsigned char buffer[0xffff];
    if(dlp_OpenDB(socket, cardno, dlpOpenRead|dlpOpenSecret, pf->info.name, &db)<0)
!     return -1;
      
    l = dlp_ReadAppBlock(socket, db, 0, buffer, 0xffff);
    if(l>0)
      pi_file_set_app_info(pf, buffer, l);
  
    if(dlp_ReadOpenDBInfo(socket, db, &l)<0)
!     return -1;
    	
    if(pf->info.flags & dlpDBFlagResource)
      for(j=0;j<l;j++) {
--- 806,833 ----
  {
    int db;
    int l,j;
!   int res = -1;
!   
!   unsigned char *buffer = NULL;
!   if(!(buffer = malloc(0xffff)))
!       exit(ENOMEM);
! 
    if(dlp_OpenDB(socket, cardno, dlpOpenRead|dlpOpenSecret, pf->info.name, &db)<0)
!   {
!       res= -1;
!       goto done;
!   }
!   
      
    l = dlp_ReadAppBlock(socket, db, 0, buffer, 0xffff);
    if(l>0)
      pi_file_set_app_info(pf, buffer, l);
  
    if(dlp_ReadOpenDBInfo(socket, db, &l)<0)
!   {
!       res = -1;
!       goto done;
!   }
    	
    if(pf->info.flags & dlpDBFlagResource)
      for(j=0;j<l;j++) {
***************
*** 819,825 ****
        if( (dlp_ReadResourceByIndex(socket, db, j, buffer, &type, &id, &size)<0) ||
          (pi_file_append_resource(pf, buffer, size, type, id)<0)) {
          dlp_CloseDB(socket, db);
!         return -1;
        }
      }
    else
--- 837,844 ----
        if( (dlp_ReadResourceByIndex(socket, db, j, buffer, &type, &id, &size)<0) ||
          (pi_file_append_resource(pf, buffer, size, type, id)<0)) {
          dlp_CloseDB(socket, db);
!         res = -1;
!         goto done;
        }
      }
    else
***************
*** 830,836 ****
    	  int category;
    	  if( (dlp_ReadRecordByIndex(socket, db, j, buffer, &id, &size, &attr, &category)<0)) {
    	    dlp_CloseDB(socket,db);
!   	    return -1;
    	  }
    	  /* There is no way to restore records with these attributes, so there is no
    	     use in backing them up */
--- 849,856 ----
    	  int category;
    	  if( (dlp_ReadRecordByIndex(socket, db, j, buffer, &id, &size, &attr, &category)<0)) {
    	    dlp_CloseDB(socket,db);
!   	    res = -1;
!             goto done;
    	  }
    	  /* There is no way to restore records with these attributes, so there is no
    	     use in backing them up */
***************
*** 838,848 ****
    	    continue;
    	  if (pi_file_append_record(pf, buffer, size, attr, category, id)<0) {
              dlp_CloseDB(socket, db);
!             return -1;
            }
    	}
    	
!   return dlp_CloseDB(socket, db);
  }  	
  
  int pi_file_install(struct pi_file * pf, int socket, int cardno)
--- 858,872 ----
    	    continue;
    	  if (pi_file_append_record(pf, buffer, size, attr, category, id)<0) {
                dlp_CloseDB(socket, db);
!               res = -1;
!               goto done;
            }
      }
  
!   res = dlp_CloseDB(socket, db);
!  done:
!   if(buffer) free(buffer);
!   return res;
  }  	
  
  int pi_file_install(struct pi_file * pf, int socket, int cardno)
diff -r -w -b -N -c /opt/src/pilot-link/libsock/qdosserial.c ./libsock/qdosserial.c
*** /opt/src/pilot-link/libsock/qdosserial.c	Thu Jan  1 01:00:00 1970
--- ./libsock/qdosserial.c	Sun Feb 28 12:04:44 1999
***************
*** 0 ****
--- 1,157 ----
+ /* unixserial.c: tty line interface code for Pilot serial comms under UNIX
+  *
+  * Copyright (c) 1996, 1997, D. Jeff Dionne & Kenneth Albanowski.
+  * This is free software, licensed under the GNU Public License V2.
+  * See the file COPYING for details.
+  */
+ 
+ #include <sys/types.h>
+ #include <sys/stat.h>
+ #include <stdio.h>
+ #include "pi-source.h"
+ #include "pi-socket.h"
+ #include "pi-serial.h"
+ #include "pi-slp.h"
+ #include "pi-syspkt.h"
+ #include "pi-padp.h"
+ #include <qdos.h>
+ #include <sys/select.h>
+ 
+ static int s_changebaud(struct pi_socket *ps);
+ static int s_close(struct pi_socket *ps);
+ static int s_write(struct pi_socket *ps);
+ static int s_read(struct pi_socket *ps, int timeout);
+ 
+ int pi_serial_open(struct pi_socket *ps, struct pi_sockaddr * addr,
+                    int addrlen)
+ {
+   char * tty = addr->pi_device;
+ 
+   int i;
+ 
+   if ((!tty) || !strlen(tty))
+     tty = getenv("PILOTPORT");
+   if (!tty)
+     tty = "<Null>";
+   
+   if ((ps->mac->fd = open(tty, O_RDWR | O_NONBLOCK )) == -1) {
+     return -1;     /* errno already set */
+   }
+ #if 0
+   if (!isatty(ps->mac->fd)) {
+     close(ps->mac->fd);
+     errno = EINVAL;
+     return -1;
+   }
+ #endif
+ 
+   if (ps->sd) {
+     int orig = ps->mac->fd;
+     ps->mac->fd = dup2(ps->mac->fd, ps->sd);
+     if (ps->mac->fd != orig)
+       close(orig);
+   }
+ 
+   ps->serial_close = s_close;
+   ps->serial_read = s_read;
+   ps->serial_write = s_write;
+   ps->serial_changebaud = s_changebaud;
+   return ps->mac->fd;
+ }
+ 
+ 
+ static int s_changebaud(struct pi_socket *ps)
+ {
+ 
+   return 0;
+ }
+ 
+ 
+ 
+ static int s_close(struct pi_socket *ps)
+ {
+   int result;
+   result = close(ps->mac->fd);
+   ps->mac->fd = 0;
+ 
+   return result;
+ }
+ 
+ static int s_write(struct pi_socket *ps)
+ {
+   struct pi_skb *skb;
+   int nwrote, len;
+   int i;
+ 
+   if (ps->txq) {
+     ps->busy++;
+ 
+     skb = ps->txq;
+     ps->txq = skb->next;
+ 
+     len = 0;
+     while (len<skb->len) {
+       nwrote = 0;
+       nwrote=write(ps->mac->fd,skb->data,skb->len);
+       if (nwrote<=0)
+         break; /* transmission failure */
+       len += nwrote;
+     }
+     ps->tx_bytes += skb->len;
+     free(skb);
+ 
+     ps->busy--;
+     
+     return 1;
+   }
+   return 0;
+ }
+ 
+ static int s_read(struct pi_socket *ps, int timeout)
+ {
+   int r;
+   unsigned char *buf;
+   int qlch;
+   
+   qlch = getchid(ps->mac->fd);
+   if(timeout == 0)
+   {
+       timeout = -1;
+   }
+   else
+   {
+       timeout *= 5;
+   }
+   
+   pi_serial_flush(ps);              /* We likely want to be in sync with tx */
+   if (!ps->mac->expect) slp_rx(ps);  /* let SLP know we want a packet */
+ 
+   while (ps->mac->expect)
+   {
+     buf = ps->mac->buf;
+ 
+     while (ps->mac->expect)
+     {
+         r = io_fstrg(qlch, timeout, buf, ps->mac->expect);
+         if(r <= 0)
+         {
+                 /* otherwise throw out any current packet and return */
+ #ifdef DEBUG
+             fprintf(stderr, "Serial RX: timeout\n");
+ #endif
+             ps->mac->state = ps->mac->expect = 1;
+             ps->mac->buf = ps->mac->rxb->data;
+             ps->rx_errors++;
+             return 0;
+         }
+         ps->rx_bytes += r;
+         buf += r;
+         ps->mac->expect -= r;
+     }
+     slp_rx(ps);
+   }
+   return 0;
+ }
+ 
+ 
+ 
diff -r -w -b -N -c /opt/src/pilot-link/libsock/serial.c ./libsock/serial.c
*** /opt/src/pilot-link/libsock/serial.c	Fri Jul 25 09:50:56 1997
--- ./libsock/serial.c	Sun Feb 28 12:05:02 1999
***************
*** 129,134 ****
--- 129,135 ----
      }
    }
    else {
+       
      if (pi_serial_open(ps, pa, addrlen) == -1) {
        return -1;     /* errno already set */
      }
diff -r -w -b -N -c /opt/src/pilot-link/libsock/socket.c ./libsock/socket.c
*** /opt/src/pilot-link/libsock/socket.c	Thu Sep 11 18:57:30 1997
--- ./libsock/socket.c	Sun Feb 28 16:00:52 1999
***************
*** 58,68 ****
  
    ps = calloc(sizeof(struct pi_socket), 1);
  
- #ifdef OS2
    if((ps->sd = open("NUL", O_RDWR))==-1) {
- #else
-   if((ps->sd = open("/dev/null", O_RDWR))==-1) {
- #endif
      int err = errno; /* Save errno of open */
      free(ps);
      errno = err;
--- 58,64 ----
***************
*** 148,154 ****
--- 144,152 ----
      conn = inet;
      
    if (conn == serial)
+   {
        return pi_serial_connect(ps, addr, addrlen);
+   }
    else if (conn == inet)
      return pi_inet_connect(ps, addr, addrlen);
      
***************
*** 182,188 ****
--- 180,188 ----
      conn = serial;
      
    if (conn == serial)
+   {
        return pi_serial_bind(ps, addr, addrlen);
+   }
    else if (conn == inet)
      return pi_inet_bind(ps, addr, addrlen);
  
***************
*** 314,319 ****
--- 314,320 ----
  
  void pi_onexit(void)
  {
+ #if 0
    struct pi_socket *p, *n;
    
    for (p=psl; p; p=n ) {
***************
*** 322,328 ****
        pi_close(p->sd);
      }
    }
!   
  }
  
  void installexit(void)
--- 323,329 ----
        pi_close(p->sd);
      }
    }
! #endif
  }
  
  void installexit(void)
diff -r -w -b -N -c /opt/src/pilot-link/libsock/sync.c ./libsock/sync.c
*** /opt/src/pilot-link/libsock/sync.c	Fri May 23 11:31:40 1997
--- ./libsock/sync.c	Sun Feb 28 19:31:21 1999
***************
*** 69,78 ****
  int SlowSync(int handle, int db, struct SyncAbs * s ) {
  	int index = 0;
  	int retval = 0;
! 	unsigned char buffer[0xffff];
  	PilotRecord p;
- 	p.record = buffer;
  	
    	/* --- Paraphrased code derived from Palm's Conduit SDK elided --- */
  	index = 0;
  	
--- 69,80 ----
  int SlowSync(int handle, int db, struct SyncAbs * s ) {
  	int index = 0;
  	int retval = 0;
! 	unsigned char *buffer;
  	PilotRecord p;
  
+         if(!(buffer=malloc(0xffff)))
+             exit(ENOMEM);
+ 	p.record = buffer;	
    	/* --- Paraphrased code derived from Palm's Conduit SDK elided --- */
  	index = 0;
  	
***************
*** 90,96 ****
  	}
  	
  	MergeToRemote(handle,db,s);
! 	
  	return retval;
  }
  
--- 92,98 ----
  	}
  	
  	MergeToRemote(handle,db,s);
! 	free(buffer);
  	return retval;
  }
  
***************
*** 100,107 ****
  int FastSync(int handle, int db, struct SyncAbs * s ) {
  	int index = 0;
  	int retval = 0;
! 	unsigned char buffer[0xffff];
  	PilotRecord p;
  	p.record = buffer;
  	
  	while(dlp_ReadNextModifiedRec(handle,db, p.record, &p.ID, &index, &p.length, &p.attr, &p.category)>=0) {
--- 102,115 ----
  int FastSync(int handle, int db, struct SyncAbs * s ) {
  	int index = 0;
  	int retval = 0;
! 	unsigned char *buffer;
  	PilotRecord p;
+ 
+         if(!(buffer = malloc(0xffff)))
+         {
+             exit(ENOMEM);
+         }
+         
          p.record = buffer;
  	
  	while(dlp_ReadNextModifiedRec(handle,db, p.record, &p.ID, &index, &p.length, &p.attr, &p.category)>=0) {
***************
*** 118,124 ****
  	}
  	
  	MergeToRemote(handle,db,s);
! 	
  	return retval;
  }
  
--- 126,132 ----
  	}
  	
  	MergeToRemote(handle,db,s);
! 	free(buffer);
  	return retval;
  }
  
***************
*** 148,156 ****
  
  /* Overwrite local (PC) with remote (Pilot) records. */
  int CopyFromRemote(int handle, int db, struct SyncAbs * s) {
! 	unsigned char buffer[0xffff];
  	int index = 0;
  	PilotRecord p;
  	p.record = buffer;
  	s->DeleteAll(s);
  	while(dlp_ReadRecordByIndex(handle,db, index, p.record, &p.ID, &p.length, &p.attr, &p.category)>=0) {
--- 156,168 ----
  
  /* Overwrite local (PC) with remote (Pilot) records. */
  int CopyFromRemote(int handle, int db, struct SyncAbs * s) {
! 	unsigned char *buffer;
  	int index = 0;
  	PilotRecord p;
+         if(!(buffer = malloc(0xffff)))
+         {
+             exit(ENOMEM);
+         }
  	p.record = buffer;
  	s->DeleteAll(s);
  	while(dlp_ReadRecordByIndex(handle,db, index, p.record, &p.ID, &p.length, &p.attr, &p.category)>=0) {
***************
*** 174,178 ****
--- 186,191 ----
  		index++;
  	}
  	dlp_CleanUpDatabase(handle,db);
+         free(buffer);
  	return 0;
  }
diff -r -w -b -N -c /opt/src/pilot-link/libsock/syspkt.c ./libsock/syspkt.c
*** /opt/src/pilot-link/libsock/syspkt.c	Fri Jul  4 07:32:07 1997
--- ./libsock/syspkt.c	Sun Feb 28 19:28:50 1999
***************
*** 311,319 ****
  int sys_ReadMemory(int sd, unsigned long addr, unsigned long len, void * dest)
  {
    int result;
!   unsigned char buf[0xffff];
    unsigned long todo,done;
    
    
    done = 0;
    do {
--- 311,321 ----
  int sys_ReadMemory(int sd, unsigned long addr, unsigned long len, void * dest)
  {
    int result;
!   unsigned char *buf;
    unsigned long todo,done;
  
+   if(!(buf=malloc(0xffff)))
+       exit(ENOMEM);
    
    done = 0;
    do {
***************
*** 337,358 ****
      result = pi_read(sd, buf, todo+6);
    
      if (result<0)
        return done;
    
      if ((buf[4] == 0x81) && ((unsigned int)result == todo+6)) {
        memcpy(((char *)dest) + done, buf+6, todo);
        done += todo;
      } else {
        return done;
      }
    } while (done < len);
    return done;
  }
  
  int sys_WriteMemory(int sd, unsigned long addr, unsigned long len, void * src)
  {
    int result;
!   unsigned char buf[0xffff];
    unsigned long todo, done;
    
    
--- 339,365 ----
      result = pi_read(sd, buf, todo+6);
    
      if (result<0)
+     {
+         free(buf);
          return done;
+     }
      
      if ((buf[4] == 0x81) && ((unsigned int)result == todo+6)) {
        memcpy(((char *)dest) + done, buf+6, todo);
        done += todo;
      } else {
+         free(buf);
          return done;
      }
    } while (done < len);
+   free(buf);
    return done;
  }
  
  int sys_WriteMemory(int sd, unsigned long addr, unsigned long len, void * src)
  {
    int result;
!   unsigned char *buf;
    unsigned long todo, done;
    
    
***************
*** 395,401 ****
               void * data, unsigned long * found)
  {
    int result;
!   unsigned char buf[0xffff];
    
    buf[0] = 0;
    buf[1] = 0;
--- 402,411 ----
               void * data, unsigned long * found)
  {
    int result;
!   unsigned char *buf;
! 
!   if(!(buf=malloc(0xffff)))
!       exit(ENOMEM);
    
    buf[0] = 0;
    buf[1] = 0;
***************
*** 415,427 ****
    
    result = pi_read(sd, buf, 12);
    
!   if (result<0)
!     return result;
!     
    if (found)
      *found = get_long(buf+6);
!   
!   return get_byte(buf+10);
  }
  
  
--- 425,438 ----
    
    result = pi_read(sd, buf, 12);
    
!   if (result<=0)
!   {
        if (found)
            *found = get_long(buf+6);
!       result = get_byte(buf+10);
!   }
!   free(buf);
!   return result;
  }
  
  
diff -r -w -b -N -c /opt/src/pilot-link/libsock/utils.c ./libsock/utils.c
*** /opt/src/pilot-link/libsock/utils.c	Tue Oct  7 13:51:39 1997
--- ./libsock/utils.c	Sun Feb 28 10:37:36 1999
***************
*** 16,21 ****
--- 16,24 ----
  # include <string.h>
  # include <assert.h>
  #endif
+ #ifdef QDOS
+ #include <sys/bsdtypes.h>
+ #endif
  
  #ifndef HAVE_INET_ATON
  # include <sys/param.h>
diff -r -w -b -N -c /opt/src/pilot-link/memos.c ./memos.c
*** /opt/src/pilot-link/memos.c	Thu Sep 11 19:06:24 1997
--- ./memos.c	Sun Feb 28 19:39:49 1999
***************
*** 14,19 ****
--- 14,23 ----
  #include "pi-memo.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "memos";
+ #endif
+ 
  int main(int argc, char *argv[])
  {
    struct pi_sockaddr addr;
***************
*** 22,30 ****
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
!   char appblock[0xffff];
    struct MemoAppInfo mai;
  
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
--- 26,40 ----
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer = 0;
!   char *appblock = 0;
    struct MemoAppInfo mai;
+   buffer = malloc(0xffff);
+   appblock = malloc(0xffff);
+   if(!buffer || !appblock)
+   {
+       exit(2);
+   }
    
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/parsedate.c ./parsedate.c
*** /opt/src/pilot-link/parsedate.c	Fri May 23 11:31:40 1997
--- ./parsedate.c	Sun Feb 28 12:19:48 1999
***************
*** 1,5 ****
  
! /*  A Bison parser, made from parsedate.y with Bison version GNU Bison version 1.22
    */
  
  #define YYBISON 1  /* Identify Bison output.  */
--- 1,6 ----
  
! /*  A Bison parser, made from parsedate.y
!  by  GNU Bison version 1.25
    */
  
  #define YYBISON 1  /* Identify Bison output.  */
***************
*** 38,44 ****
  #include <sys/types.h>
  #include <ctype.h>
  #include <time.h>
! 
  int date_lex();
  
  #define yyparse		date_parse
--- 39,48 ----
  #include <sys/types.h>
  #include <ctype.h>
  #include <time.h>
! #ifdef QDOS
! #include <stdlib.h>
! # include <string.h>
! #endif
  int date_lex();
  
  #define yyparse		date_parse
***************
*** 113,140 ****
  
  static void		date_error();
  
! #line 100 "parsedate.y"
  typedef union {
      time_t		Number;
      enum _MERIDIAN	Meridian;
  } YYSTYPE;
- 
- #ifndef YYLTYPE
- typedef
-   struct yyltype
-     {
-       int timestamp;
-       int first_line;
-       int first_column;
-       int last_line;
-       int last_column;
-       char *text;
-    }
-   yyltype;
- 
- #define YYLTYPE yyltype
- #endif
- 
  #include <stdio.h>
  
  #ifndef __cplusplus
--- 117,127 ----
  
  static void		date_error();
  
! #line 103 "parsedate.y"
  typedef union {
      time_t		Number;
      enum _MERIDIAN	Meridian;
  } YYSTYPE;
  #include <stdio.h>
  
  #ifndef __cplusplus
***************
*** 205,219 ****
  
  #if YYDEBUG != 0
  static const short yyrline[] = { 0,
!    114,   115,   118,   127,   131,   134,   139,   151,   157,   164,
!    170,   180,   184,   188,   196,   202,   223,   227,   239,   243,
!    248,   252,   257,   264,   267,   270,   273,   278,   281
  };
  
! static const char * const yytname[] = {   "$","error","$illegal.","tDAY","tDAYZONE",
  "tMERIDIAN","tMONTH","tMONTH_UNIT","tSEC_UNIT","tSNUMBER","tUNUMBER","tZONE",
! "':'","'/'","','","spec","item","time","zone","numzone","date","rel","o_merid",
! ""
  };
  #endif
  
--- 192,209 ----
  
  #if YYDEBUG != 0
  static const short yyrline[] = { 0,
!    117,   118,   121,   130,   134,   137,   142,   154,   160,   167,
!    173,   183,   187,   191,   199,   205,   226,   230,   242,   246,
!    251,   255,   260,   267,   270,   273,   276,   281,   284
  };
+ #endif
  
! 
! #if YYDEBUG != 0 || defined (YYERROR_VERBOSE)
! 
! static const char * const yytname[] = {   "$","error","$undefined.","tDAY","tDAYZONE",
  "tMERIDIAN","tMONTH","tMONTH_UNIT","tSEC_UNIT","tSNUMBER","tUNUMBER","tZONE",
! "':'","'/'","','","spec","item","time","zone","numzone","date","rel","o_merid", NULL
  };
  #endif
  
***************
*** 274,284 ****
  #line 3 "/usr/lib/bison.simple"
  
  /* Skeleton output parser for bison,
!    Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman
  
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
!    the Free Software Foundation; either version 1, or (at your option)
     any later version.
  
     This program is distributed in the hope that it will be useful,
--- 264,274 ----
  #line 3 "/usr/lib/bison.simple"
  
  /* Skeleton output parser for bison,
!    Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.
  
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
!    the Free Software Foundation; either version 2, or (at your option)
     any later version.
  
     This program is distributed in the hope that it will be useful,
***************
*** 290,295 ****
--- 280,289 ----
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
  
+ /* As a special exception, when this file is copied by Bison into a
+    Bison output file, you may use that output file without restriction.
+    This special exception was added by the Free Software Foundation
+    in version 1.24 of Bison.  */
  
  #ifndef alloca
  #ifdef __GNUC__
***************
*** 363,372 ****
--- 357,374 ----
  
  #ifdef YYPURE
  #ifdef YYLSP_NEEDED
+ #ifdef YYLEX_PARAM
+ #define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
+ #else
  #define YYLEX		yylex(&yylval, &yylloc)
+ #endif
+ #else /* not YYLSP_NEEDED */
+ #ifdef YYLEX_PARAM
+ #define YYLEX		yylex(&yylval, YYLEX_PARAM)
  #else
  #define YYLEX		yylex(&yylval)
  #endif
+ #endif /* not YYLSP_NEEDED */
  #endif
  
  /* If nonreentrant, generate the variables here */
***************
*** 414,429 ****
  #endif
  
  #if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
! #define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
  #else				/* not GNU C or C++ */
  #ifndef __cplusplus
  
  /* This is the most reliable way to avoid incompatibilities
     in available built-in functions on various systems.  */
  static void
! __yy_bcopy (from, to, count)
!      char *from;
       char *to;
       int count;
  {
    register char *f = from;
--- 416,431 ----
  #endif
  
  #if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
! #define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
  #else				/* not GNU C or C++ */
  #ifndef __cplusplus
  
  /* This is the most reliable way to avoid incompatibilities
     in available built-in functions on various systems.  */
  static void
! __yy_memcpy (to, from, count)
       char *to;
+      char *from;
       int count;
  {
    register char *f = from;
***************
*** 439,445 ****
  /* This is the most reliable way to avoid incompatibilities
     in available built-in functions on various systems.  */
  static void
! __yy_bcopy (char *from, char *to, int count)
  {
    register char *f = from;
    register char *t = to;
--- 441,447 ----
  /* This is the most reliable way to avoid incompatibilities
     in available built-in functions on various systems.  */
  static void
! __yy_memcpy (char *to, char *from, int count)
  {
    register char *f = from;
    register char *t = to;
***************
*** 452,460 ****
  #endif
  #endif
  
! #line 184 "/usr/lib/bison.simple"
  int
! yyparse()
  {
    register int yystate;
    register int yyn;
--- 454,483 ----
  #endif
  #endif
  
! #line 196 "/usr/lib/bison.simple"
! 
! /* The user can define YYPARSE_PARAM as the name of an argument to be passed
!    into yyparse.  The argument should have type void *.
!    It should actually point to an object.
!    Grammar actions can access the variable by casting it
!    to the proper pointer type.  */
! 
! #ifdef YYPARSE_PARAM
! #ifdef __cplusplus
! #define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
! #define YYPARSE_PARAM_DECL
! #else /* not __cplusplus */
! #define YYPARSE_PARAM_ARG YYPARSE_PARAM
! #define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
! #endif /* not __cplusplus */
! #else /* not YYPARSE_PARAM */
! #define YYPARSE_PARAM_ARG
! #define YYPARSE_PARAM_DECL
! #endif /* not YYPARSE_PARAM */
! 
  int
! yyparse(YYPARSE_PARAM_ARG)
!      YYPARSE_PARAM_DECL
  {
    register int yystate;
    register int yyn;
***************
*** 570,581 ****
        if (yystacksize > YYMAXDEPTH)
  	yystacksize = YYMAXDEPTH;
        yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
!       __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
        yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
!       __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
  #ifdef YYLSP_NEEDED
        yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
!       __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
  #endif
  #endif /* no yyoverflow */
  
--- 593,604 ----
        if (yystacksize > YYMAXDEPTH)
  	yystacksize = YYMAXDEPTH;
        yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
!       __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
        yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
!       __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
  #ifdef YYLSP_NEEDED
        yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
!       __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
  #endif
  #endif /* no yyoverflow */
  
***************
*** 736,742 ****
    switch (yyn) {
  
  case 3:
! #line 118 "parsedate.y"
  {
  	    yyHaveTime++;
  #ifdef lint
--- 759,765 ----
    switch (yyn) {
  
  case 3:
! #line 121 "parsedate.y"
  {
  	    yyHaveTime++;
  #ifdef lint
***************
*** 748,773 ****
  	;
      break;}
  case 4:
! #line 127 "parsedate.y"
  {
  	    yyHaveTime++;
  	    yyTimezone = yyvsp[0].Number;
  	;
      break;}
  case 5:
! #line 131 "parsedate.y"
  {
  	    yyHaveDate++;
  	;
      break;}
  case 6:
! #line 134 "parsedate.y"
  {
  	    yyHaveRel = 1;
  	;
      break;}
  case 7:
! #line 139 "parsedate.y"
  {
  	    if (yyvsp[-1].Number < 100) {
  		yyHour = yyvsp[-1].Number;
--- 771,796 ----
  	;
      break;}
  case 4:
! #line 130 "parsedate.y"
  {
  	    yyHaveTime++;
  	    yyTimezone = yyvsp[0].Number;
  	;
      break;}
  case 5:
! #line 134 "parsedate.y"
  {
  	    yyHaveDate++;
  	;
      break;}
  case 6:
! #line 137 "parsedate.y"
  {
  	    yyHaveRel = 1;
  	;
      break;}
  case 7:
! #line 142 "parsedate.y"
  {
  	    if (yyvsp[-1].Number < 100) {
  		yyHour = yyvsp[-1].Number;
***************
*** 782,788 ****
  	;
      break;}
  case 8:
! #line 151 "parsedate.y"
  {
  	    yyHour = yyvsp[-3].Number;
  	    yyMinutes = yyvsp[-1].Number;
--- 805,811 ----
  	;
      break;}
  case 8:
! #line 154 "parsedate.y"
  {
  	    yyHour = yyvsp[-3].Number;
  	    yyMinutes = yyvsp[-1].Number;
***************
*** 791,797 ****
  	;
      break;}
  case 9:
! #line 157 "parsedate.y"
  {
  	    yyHour = yyvsp[-3].Number;
  	    yyMinutes = yyvsp[-1].Number;
--- 814,820 ----
  	;
      break;}
  case 9:
! #line 160 "parsedate.y"
  {
  	    yyHour = yyvsp[-3].Number;
  	    yyMinutes = yyvsp[-1].Number;
***************
*** 801,807 ****
  	;
      break;}
  case 10:
! #line 164 "parsedate.y"
  {
  	    yyHour = yyvsp[-5].Number;
  	    yyMinutes = yyvsp[-3].Number;
--- 824,830 ----
  	;
      break;}
  case 10:
! #line 167 "parsedate.y"
  {
  	    yyHour = yyvsp[-5].Number;
  	    yyMinutes = yyvsp[-3].Number;
***************
*** 810,816 ****
  	;
      break;}
  case 11:
! #line 170 "parsedate.y"
  {
  	    yyHour = yyvsp[-5].Number;
  	    yyMinutes = yyvsp[-3].Number;
--- 833,839 ----
  	;
      break;}
  case 11:
! #line 173 "parsedate.y"
  {
  	    yyHour = yyvsp[-5].Number;
  	    yyMinutes = yyvsp[-3].Number;
***************
*** 821,841 ****
  	;
      break;}
  case 12:
! #line 180 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSToff;
  	;
      break;}
  case 13:
! #line 184 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSTon;
  	;
      break;}
  case 14:
! #line 188 "parsedate.y"
  {
  	    /* Only allow "GMT+300" and "GMT-0800" */
  	    if (yyvsp[-1].Number != 0) {
--- 844,864 ----
  	;
      break;}
  case 12:
! #line 183 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSToff;
  	;
      break;}
  case 13:
! #line 187 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSTon;
  	;
      break;}
  case 14:
! #line 191 "parsedate.y"
  {
  	    /* Only allow "GMT+300" and "GMT-0800" */
  	    if (yyvsp[-1].Number != 0) {
***************
*** 846,859 ****
  	;
      break;}
  case 15:
! #line 196 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSToff;
  	;
      break;}
  case 16:
! #line 202 "parsedate.y"
  {
  	    int		i;
  
--- 869,882 ----
  	;
      break;}
  case 15:
! #line 199 "parsedate.y"
  {
  	    yyval.Number = yyvsp[0].Number;
  	    yyDSTmode = DSToff;
  	;
      break;}
  case 16:
! #line 205 "parsedate.y"
  {
  	    int		i;
  
***************
*** 875,888 ****
  	;
      break;}
  case 17:
! #line 223 "parsedate.y"
  {
  	    yyMonth = yyvsp[-2].Number;
  	    yyDay = yyvsp[0].Number;
  	;
      break;}
  case 18:
! #line 227 "parsedate.y"
  {
  	    if (yyvsp[-4].Number > 100) {
  		yyYear = yyvsp[-4].Number;
--- 898,911 ----
  	;
      break;}
  case 17:
! #line 226 "parsedate.y"
  {
  	    yyMonth = yyvsp[-2].Number;
  	    yyDay = yyvsp[0].Number;
  	;
      break;}
  case 18:
! #line 230 "parsedate.y"
  {
  	    if (yyvsp[-4].Number > 100) {
  		yyYear = yyvsp[-4].Number;
***************
*** 897,910 ****
  	;
      break;}
  case 19:
! #line 239 "parsedate.y"
  {
  	    yyMonth = yyvsp[-1].Number;
  	    yyDay = yyvsp[0].Number;
  	;
      break;}
  case 20:
! #line 243 "parsedate.y"
  {
  	    yyMonth = yyvsp[-3].Number;
  	    yyDay = yyvsp[-2].Number;
--- 920,933 ----
  	;
      break;}
  case 19:
! #line 242 "parsedate.y"
  {
  	    yyMonth = yyvsp[-1].Number;
  	    yyDay = yyvsp[0].Number;
  	;
      break;}
  case 20:
! #line 246 "parsedate.y"
  {
  	    yyMonth = yyvsp[-3].Number;
  	    yyDay = yyvsp[-2].Number;
***************
*** 912,925 ****
  	;
      break;}
  case 21:
! #line 248 "parsedate.y"
  {
  	    yyDay = yyvsp[-1].Number;
  	    yyMonth = yyvsp[0].Number;
  	;
      break;}
  case 22:
! #line 252 "parsedate.y"
  {
  	    yyDay = yyvsp[-2].Number;
  	    yyMonth = yyvsp[-1].Number;
--- 935,948 ----
  	;
      break;}
  case 21:
! #line 251 "parsedate.y"
  {
  	    yyDay = yyvsp[-1].Number;
  	    yyMonth = yyvsp[0].Number;
  	;
      break;}
  case 22:
! #line 255 "parsedate.y"
  {
  	    yyDay = yyvsp[-2].Number;
  	    yyMonth = yyvsp[-1].Number;
***************
*** 927,933 ****
  	;
      break;}
  case 23:
! #line 257 "parsedate.y"
  {
  	    yyDay = yyvsp[-2].Number;
  	    yyMonth = yyvsp[-1].Number;
--- 950,956 ----
  	;
      break;}
  case 23:
! #line 260 "parsedate.y"
  {
  	    yyDay = yyvsp[-2].Number;
  	    yyMonth = yyvsp[-1].Number;
***************
*** 935,978 ****
  	;
      break;}
  case 24:
! #line 264 "parsedate.y"
  {
  	    yyRelSeconds += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 25:
! #line 267 "parsedate.y"
  {
  	    yyRelSeconds += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 26:
! #line 270 "parsedate.y"
  {
  	    yyRelMonth += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 27:
! #line 273 "parsedate.y"
  {
  	    yyRelMonth += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 28:
! #line 278 "parsedate.y"
  {
  	    yyval.Meridian = MER24;
  	;
      break;}
  case 29:
! #line 281 "parsedate.y"
  {
  	    yyval.Meridian = yyvsp[0].Meridian;
  	;
      break;}
  }
     /* the action file gets copied in in place of this dollarsign */
! #line 465 "/usr/lib/bison.simple"
  
    yyvsp -= yylen;
    yyssp -= yylen;
--- 958,1001 ----
  	;
      break;}
  case 24:
! #line 267 "parsedate.y"
  {
  	    yyRelSeconds += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 25:
! #line 270 "parsedate.y"
  {
  	    yyRelSeconds += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 26:
! #line 273 "parsedate.y"
  {
  	    yyRelMonth += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 27:
! #line 276 "parsedate.y"
  {
  	    yyRelMonth += yyvsp[-1].Number * yyvsp[0].Number;
  	;
      break;}
  case 28:
! #line 281 "parsedate.y"
  {
  	    yyval.Meridian = MER24;
  	;
      break;}
  case 29:
! #line 284 "parsedate.y"
  {
  	    yyval.Meridian = yyvsp[0].Meridian;
  	;
      break;}
  }
     /* the action file gets copied in in place of this dollarsign */
! #line 498 "/usr/lib/bison.simple"
  
    yyvsp -= yylen;
    yyssp -= yylen;
***************
*** 1168,1174 ****
    yystate = yyn;
    goto yynewstate;
  }
! #line 286 "parsedate.y"
  
  
  /* Month and day table. */
--- 1191,1197 ----
    yystate = yyn;
    goto yynewstate;
  }
! #line 289 "parsedate.y"
  
  
  /* Month and day table. */
diff -r -w -b -N -c /opt/src/pilot-link/parsedate.y ./parsedate.y
*** /opt/src/pilot-link/parsedate.y	Fri May 23 11:31:40 1997
--- ./parsedate.y	Sun Feb 28 12:19:40 1999
***************
*** 21,27 ****
  #include <sys/types.h>
  #include <ctype.h>
  #include <time.h>
! 
  int date_lex();
  
  #define yyparse		date_parse
--- 21,30 ----
  #include <sys/types.h>
  #include <ctype.h>
  #include <time.h>
! #ifdef QDOS
! #include <stdlib.h>
! # include <string.h>
! #endif
  int date_lex();
  
  #define yyparse		date_parse
diff -r -w -b -N -c /opt/src/pilot-link/pi-csd.c ./pi-csd.c
*** /opt/src/pilot-link/pi-csd.c	Sun Aug 17 15:26:59 1997
--- ./pi-csd.c	Sun Feb 28 12:17:42 1999
***************
*** 20,26 ****
--- 20,28 ----
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <netinet/in.h>
+ #ifndef QDOS
  #include <net/if.h>
+ #endif
  #include <arpa/inet.h>
  #include <netdb.h>
  
diff -r -w -b -N -c /opt/src/pilot-link/pi-getram.c ./pi-getram.c
*** /opt/src/pilot-link/pi-getram.c	Mon Sep 15 02:14:49 1997
--- ./pi-getram.c	Sun Feb 28 12:17:47 1999
***************
*** 137,143 ****
    file = open(name,O_RDWR|O_CREAT,0666);
  
    offset = lseek(file, 0, SEEK_END);
!   offset &= ~255;
    lseek(file, offset, SEEK_SET);
  
    PackRPC(&p, 0xA164, RPC_IntReply, RPC_Byte(1), RPC_End);
--- 137,143 ----
    file = open(name,O_RDWR|O_CREAT,0666);
  
    offset = lseek(file, 0, SEEK_END);
!   offset &= (unsigned long)~255;
    lseek(file, offset, SEEK_SET);
  
    PackRPC(&p, 0xA164, RPC_IntReply, RPC_Byte(1), RPC_End);
diff -r -w -b -N -c /opt/src/pilot-link/pi-getrom.c ./pi-getrom.c
*** /opt/src/pilot-link/pi-getrom.c	Mon Feb 15 21:01:47 1999
--- ./pi-getrom.c	Sun Feb 28 12:17:48 1999
***************
*** 122,128 ****
      file = open (name, O_RDWR | O_CREAT, 0666);
  
      offset = lseek (file, 0, SEEK_END);
!     offset &= ~255;
      lseek (file, offset, SEEK_SET);
  
      PackRPC (&p, 0xA164, RPC_IntReply, RPC_Byte (1), RPC_End);
--- 122,128 ----
      file = open (name, O_RDWR | O_CREAT, 0666);
  
      offset = lseek (file, 0, SEEK_END);
!     offset &= (unsigned long)~255;
      lseek (file, offset, SEEK_SET);
  
      PackRPC (&p, 0xA164, RPC_IntReply, RPC_Byte (1), RPC_End);
diff -r -w -b -N -c /opt/src/pilot-link/pi-port.c ./pi-port.c
*** /opt/src/pilot-link/pi-port.c	Thu Sep 11 19:09:52 1997
--- ./pi-port.c	Sun Feb 28 19:42:04 1999
***************
*** 23,37 ****
  #include <arpa/inet.h>
  #include <netdb.h>
  
  void sigint(int num)
  {
!   *((char*)0)=0;
  }
  
  void do_read(struct pi_socket * ps, int type, char * buffer, int length)
  {
    fprintf(stderr, "A %d byte packet of type %d has been received from the network\n", length, type);
!   dumpdata(buffer, length);
    if (type == 0 ) {
      struct pi_skb * nskb;
      nskb = (struct pi_skb *)malloc(sizeof(struct pi_skb));
--- 23,41 ----
  #include <arpa/inet.h>
  #include <netdb.h>
  
+ #ifdef QDOS
+ char _prog_name[] = "pi-port";
+ #endif
+ 
  void sigint(int num)
  {
! //  *((char*)0)=0; // Arrrrrgh (jh) is this some sort of joke ?
  }
  
  void do_read(struct pi_socket * ps, int type, char * buffer, int length)
  {
    fprintf(stderr, "A %d byte packet of type %d has been received from the network\n", length, type);
!   dumpdata((const unsigned char *)buffer, length);
    if (type == 0 ) {
      struct pi_skb * nskb;
      nskb = (struct pi_skb *)malloc(sizeof(struct pi_skb));
***************
*** 154,160 ****
            goto skip;
            
          fprintf(stderr, "Read %d bytes from network at block+%d:\n", r, l);
!         dumpdata(buffer+l, r);
            
          l += r;
          if (l>=4) {
--- 158,164 ----
            goto skip;
            
          fprintf(stderr, "Read %d bytes from network at block+%d:\n", r, l);
!         dumpdata((const unsigned char *)(buffer+l), r);
            
          l += r;
          if (l>=4) {
***************
*** 167,173 ****
                memmove(buffer,buffer+4+blen,l);
              }
              fprintf(stderr, "Buffer now is:\n");
!             dumpdata(buffer, l);
            }
          }
          skip:
--- 171,177 ----
                memmove(buffer,buffer+4+blen,l);
              }
              fprintf(stderr, "Buffer now is:\n");
!             dumpdata((const unsigned char *)buffer, l);
            }
          }
          skip:
diff -r -w -b -N -c /opt/src/pilot-link/pilot-addresses.c ./pilot-addresses.c
*** /opt/src/pilot-link/pilot-addresses.c	Thu Sep 11 18:58:54 1997
--- ./pilot-addresses.c	Sun Feb 28 19:37:35 1999
***************
*** 11,16 ****
--- 11,20 ----
  #include "pi-dlp.h"
  #include "pi-address.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-addresses";
+ #endif
+ 
  /* Yet more hair: reorganize fields to match visible appearence */
  
  int realentry[19] =   { 0, 1, 13, 2, 
***************
*** 150,157 ****
  {
    struct Address a;
    int i,l;
!   char buf[0xffff];
    int category,attribute;
  
    do {
      i = read_field(buf,in);
--- 154,163 ----
  {
    struct Address a;
    int i,l;
!   char *buf;
    int category,attribute;
+   if(!(buf=malloc(0xffff)))
+       exit(2);
  
    do {
      i = read_field(buf,in);
***************
*** 217,222 ****
--- 223,229 ----
      dlp_WriteRecord(sd, db, attribute, 0, category, (unsigned char *)buf, l, 0);
      
    } while(i >= 0);
+   free(buf);
    
    return 0;
  }
***************
*** 227,235 ****
  {
    struct Address a;
    int i,j,l;
!   char buf[0xffff];
    int category,attribute;
    
    for(i=0;
        (j=dlp_ReadRecordByIndex(sd, db, i, (unsigned char *)buf, 0, &l, &attribute, &category))>=0;
        i++)
--- 234,245 ----
  {
    struct Address a;
    int i,j,l;
!   char *buf;
    int category,attribute;
  
+   if(!(buf = malloc(0xffff)))
+       exit(ENOMEM);
+   
    for(i=0;
        (j=dlp_ReadRecordByIndex(sd, db, i, (unsigned char *)buf, 0, &l, &attribute, &category))>=0;
        i++)
***************
*** 290,295 ****
--- 300,306 ----
      
  #endif
    }
+   free(buf);
    
    return 0;
  }
***************
*** 310,316 ****
    int l;
    struct PilotUser U;
    int ret;
!   char buf[0xffff];
    struct AddressAppInfo aai;
    char * defaultcategoryname = 0;
    char * deletecategory = 0;
--- 321,327 ----
    int l;
    struct PilotUser U;
    int ret;
!   char *buf;
    struct AddressAppInfo aai;
    char * defaultcategoryname = 0;
    char * deletecategory = 0;
***************
*** 357,362 ****
--- 368,375 ----
      perror("pi_socket");
      exit(1);
    }
+   if(!(buf = malloc(0xffff)))
+       exit(ENOMEM);
    
    addr.pi_family = PI_AF_SLP;
    strcpy(addr.pi_device,argv[1]);
diff -r -w -b -N -c /opt/src/pilot-link/pilot-clip.c ./pilot-clip.c
*** /opt/src/pilot-link/pilot-clip.c	Thu Sep 11 18:59:07 1997
--- ./pilot-clip.c	Sun Feb 28 19:37:55 1999
***************
*** 11,16 ****
--- 11,20 ----
  #include "pi-syspkt.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-clip";
+ #endif
+ 
  void * GetClip(int socket, int type, int * length)
  {
    struct RPC_params p;
***************
*** 96,102 ****
    struct pi_sockaddr addr;
    int sd;
    int ret;
!   char buffer[0xffff];
  
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s -s|-g\n",argv[0],TTYPrompt);
--- 100,109 ----
    struct pi_sockaddr addr;
    int sd;
    int ret;
!   char *buffer;
! 
!   if(!(buffer=malloc(0xffff)))
!       exit(ENOMEM);
  
    if (argc < 3) {
      fprintf(stderr,"usage:%s %s -s|-g\n",argv[0],TTYPrompt);
***************
*** 139,145 ****
    
    if (strcmp(argv[2], "-s")==0) {
      ret = read(fileno(stdin), buffer, 0xffff);
!     dumpdata(buffer, ret);
      if (ret>=0) {
        buffer[ret++] = 0;
        SetClip(sd, 0, buffer, ret);
--- 146,152 ----
    
    if (strcmp(argv[2], "-s")==0) {
      ret = read(fileno(stdin), buffer, 0xffff);
!     dumpdata((const unsigned char *)buffer, ret);
      if (ret>=0) {
        buffer[ret++] = 0;
        SetClip(sd, 0, buffer, ret);
diff -r -w -b -N -c /opt/src/pilot-link/pilot-dedupe.c ./pilot-dedupe.c
*** /opt/src/pilot-link/pilot-dedupe.c	Thu Sep 11 18:57:49 1997
--- ./pilot-dedupe.c	Sun Feb 28 19:35:09 1999
***************
*** 12,17 ****
--- 12,21 ----
  
  char * progname;
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-dedupe";
+ #endif
+ 
  void Help(void)
  {
    fprintf(stderr,"usage:%s %s dbname [dbname ...]\n",progname,TTYPrompt);
***************
*** 37,49 ****
    int l;
    struct PilotUser U;
    int ret;
!   char buf[0xffff];
    int i;
    struct record * r;
  #ifdef sun
    extern char* optarg;
    extern int optind;
  #endif
  
    progname = argv[0];
  
--- 41,55 ----
    int l;
    struct PilotUser U;
    int ret;
!   char *buf;
    int i;
    struct record * r;
  #ifdef sun
    extern char* optarg;
    extern int optind;
  #endif
+   if(!(buf=malloc(0xffff)))
+       exit(ENOMEM);
  
    progname = argv[0];
  
diff -r -w -b -N -c /opt/src/pilot-link/pilot-file.c ./pilot-file.c
*** /opt/src/pilot-link/pilot-file.c	Mon Aug  4 02:38:46 1997
--- ./pilot-file.c	Sun Feb 28 19:34:38 1999
***************
*** 32,37 ****
--- 32,40 ----
  void dump (void *buf, int size);
  
  char * progname;
+ #ifdef QDOS
+ char _prog_name[] = "pilot-file";
+ #endif
  
  void
  usage (void)
diff -r -w -b -N -c /opt/src/pilot-link/pilot-mail.c ./pilot-mail.c
*** /opt/src/pilot-link/pilot-mail.c	Thu Sep 11 19:02:58 1997
--- ./pilot-mail.c	Sun Feb 28 19:38:15 1999
***************
*** 38,43 ****
--- 38,47 ----
  #include <arpa/inet.h>
  #include <netdb.h>
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-mail";
+ #endif
+ 
  extern time_t parsedate(char * p);
  
  void markline(char *msg) {
***************
*** 218,224 ****
    int lost,dupe,rec,sent;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
    struct MailAppInfo tai;
    struct MailSyncPref p;
    struct MailSignaturePref sig;
--- 222,228 ----
    int lost,dupe,rec,sent;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer;
    struct MailAppInfo tai;
    struct MailSyncPref p;
    struct MailSignaturePref sig;
***************
*** 286,291 ****
--- 290,297 ----
    extern char* optarg;
    extern int optind;
    
+   if(!(buffer=malloc(0xffff)))
+       exit(ENOMEM);
  
    if (getenv("SENDMAIL"))
      sendmail = getenv("SENDMAIL");
***************
*** 597,603 ****
    /* POP retrieval section */
    
    memset((char*)&pop_addr, 0, sizeof(pop_addr));
!   if ((pop_addr.sin_addr.s_addr = inet_addr(pop_host))==-1) {
      hostent = gethostbyname(pop_host);
      if (!hostent) {
        fprintf(stderr, "Unable to resolve POP host '%s'", pop_host);
--- 603,609 ----
    /* POP retrieval section */
    
    memset((char*)&pop_addr, 0, sizeof(pop_addr));
!   if ((pop_addr.sin_addr.s_addr = inet_addr(pop_host)) == (unsigned long)-1) {
      hostent = gethostbyname(pop_host);
      if (!hostent) {
        fprintf(stderr, "Unable to resolve POP host '%s'", pop_host);
***************
*** 625,640 ****
      goto endpop;
    }  
    
!   sprintf(buffer, "USER %s\r\n", pop_user);
!   write(popfd, buffer, strlen(buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "USER command to POP server failed\n");
      goto endpop;
    }
  
!   sprintf(buffer, "PASS %s\r\n", pop_pass);
!   write(popfd, buffer, strlen(buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "PASS command to POP server failed\n");
--- 631,646 ----
      goto endpop;
    }  
    
!   sprintf((char*)buffer, "USER %s\r\n", pop_user);
!   write(popfd, buffer, strlen((char*)buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "USER command to POP server failed\n");
      goto endpop;
    }
  
!   sprintf((char*)buffer, "PASS %s\r\n", pop_pass);
!   write(popfd, buffer, strlen((char*)buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "PASS command to POP server failed\n");
***************
*** 658,665 ****
      t.body = 0;
      t.dated = 0;
      
!     sprintf(buffer, "LIST %d\r\n", i);
!     write(popfd, buffer, strlen(buffer));
      l = read(popfd, buffer, 1024);
      if (l<0) {
        perror("Unable to read from socket");
--- 664,671 ----
      t.body = 0;
      t.dated = 0;
      
!     sprintf((char*)buffer, "LIST %d\r\n", i);
!     write(popfd, buffer, strlen((char*)buffer));
      l = read(popfd, buffer, 1024);
      if (l<0) {
        perror("Unable to read from socket");
***************
*** 669,682 ****
      if (buffer[0] != '+')
        break;
      
!     sscanf(buffer, "%*s %*d %d", &len);
      
      if (len > 16000) 
        continue; 
  
!     sprintf(buffer, "RETR %d\r\n", i);
!     write(popfd, buffer, strlen(buffer));
!     l = getpopstring(popfd, buffer);
      if ((l < 0) || (buffer[0] != '+')) {
        /* Weird */
        continue;
--- 675,688 ----
      if (buffer[0] != '+')
        break;
      
!     sscanf((char*)buffer, "%*s %*d %d", &len);
      
      if (len > 16000) 
        continue; 
  
!     sprintf((char*)buffer, "RETR %d\r\n", i);
!     write(popfd, (char*)buffer, strlen((char*)buffer));
!     l = getpopstring(popfd, (char*)buffer);
      if ((l < 0) || (buffer[0] != '+')) {
        /* Weird */
        continue;
***************
*** 733,747 ****
        continue;
      }
      
!     t.body = strdup(buffer);
      
      len = pack_Mail(&t, buffer, 0xffff);
      
      if (dlp_WriteRecord(sd, db, 0, 0, 0, buffer, len, 0)>0) {
        rec++;
        if (strcmp(pop_keep,"delete")==0) { 
!         sprintf(buffer, "DELE %d\r\n", i);
!         write(popfd, buffer, strlen(buffer));
          read(popfd, buffer, 1024);
          if (buffer[0] != '+') {
            fprintf(stderr, "Error deleting message %d\n", i);
--- 739,753 ----
        continue;
      }
      
!     t.body = strdup((char*)buffer);
      
      len = pack_Mail(&t, buffer, 0xffff);
      
      if (dlp_WriteRecord(sd, db, 0, 0, 0, buffer, len, 0)>0) {
        rec++;
        if (strcmp(pop_keep,"delete")==0) { 
!         sprintf((char*)buffer, "DELE %d\r\n", i);
!         write(popfd, buffer, strlen((char*)buffer));
          read(popfd, buffer, 1024);
          if (buffer[0] != '+') {
            fprintf(stderr, "Error deleting message %d\n", i);
***************
*** 756,763 ****
      free_Mail(&t);
    }
    
!   sprintf(buffer, "QUIT\r\n");
!   write(popfd, buffer, strlen(buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "QUIT command to POP server failed\n");
--- 762,769 ----
      free_Mail(&t);
    }
    
!   sprintf((char*)buffer, "QUIT\r\n");
!   write(popfd, buffer, strlen((char*)buffer));
    read(popfd, buffer, 1024);
    if (buffer[0] != '+') {
      fprintf(stderr, "QUIT command to POP server failed\n");
***************
*** 892,903 ****
    /* Close the database */
    dlp_CloseDB(sd, db);
  
!   sprintf(buffer, "Finished transferring mail. %d message%s sent, %d message%s received.\n",
      sent, (sent == 1) ? "" : "s", rec, (rec == 1) ? "" : "s");
    if (lost || dupe)
!     sprintf(buffer+strlen(buffer), "(And %d lost, %d duplicated. Sorry.)\n", lost, dupe);
!   fprintf(stderr, buffer);  
!   dlp_AddSyncLogEntry(sd, buffer);
  
    pi_close(sd);
    return 0;
--- 898,909 ----
    /* Close the database */
    dlp_CloseDB(sd, db);
  
!   sprintf((char*)buffer, "Finished transferring mail. %d message%s sent, %d message%s received.\n",
      sent, (sent == 1) ? "" : "s", rec, (rec == 1) ? "" : "s");
    if (lost || dupe)
!     sprintf((char*)buffer+strlen((char*)buffer), "(And %d lost, %d duplicated. Sorry.)\n", lost, dupe);
!   fprintf(stderr, (char*)buffer);  
!   dlp_AddSyncLogEntry(sd, (char*)buffer);
  
    pi_close(sd);
    return 0;
diff -r -w -b -N -c /opt/src/pilot-link/pilot-schlep.c ./pilot-schlep.c
*** /opt/src/pilot-link/pilot-schlep.c	Thu Sep 11 18:58:05 1997
--- ./pilot-schlep.c	Sun Feb 28 19:35:33 1999
***************
*** 17,22 ****
--- 17,26 ----
  
  #define pi_mktag(c1,c2,c3,c4) (((c1)<<24)|((c2)<<16)|((c3)<<8)|(c4))
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-schlep";
+ #endif
+ 
  int sd = 0;
  char * device;
  char * progname;
***************
*** 104,110 ****
    int j;
    int db;
    int l;
!   char buffer[0xffff];
    
    if (isatty(fileno(stdin))) {
      fprintf(stderr, "Cannot install from tty, please redirect from file.\n");
--- 108,115 ----
    int j;
    int db;
    int l;
!   char *buffer;
! 
     
    if (isatty(fileno(stdin))) {
      fprintf(stderr, "Cannot install from tty, please redirect from file.\n");
***************
*** 118,127 ****
      exit(1);
    }
  
!   dlp_DeleteDB(sd, 0, "Schlep");
!   if (dlp_CreateDB(sd, pi_mktag('S','h','l','p'), pi_mktag('D','A','T','A'), 0, dlpDBFlagResource, 1, "Schlep", &db)<0)
!     return;
    
    fprintf(stderr,"Please wait, installing data");
    
    l = 0;
--- 123,134 ----
      exit(1);
    }
  
!   if(!(buffer=malloc(0xffff)))
!       exit(2);
  
+   dlp_DeleteDB(sd, 0, "Schlep");
+   if (dlp_CreateDB(sd, pi_mktag('S','h','l','p'), pi_mktag('D','A','T','A'), 0, dlpDBFlagResource, 1, "Schlep", &db)>=0)
+   {
        fprintf(stderr,"Please wait, installing data");
    
        l = 0;
***************
*** 132,147 ****
      fprintf(stderr,".");
    }
    fprintf(stderr,"\n%d bytes written\n", l);
-   
    dlp_CloseDB(sd, db);
  }
  
  void Fetch(void)
  {
    int db;
    int i;
    int l;
!   char buffer[0xffff];
       	
    Connect();
  
--- 139,156 ----
            fprintf(stderr,".");
        }
        fprintf(stderr,"\n%d bytes written\n", l);
        dlp_CloseDB(sd, db);
    }
+   free(buffer);
+ }
  
  void Fetch(void)
  {
    int db;
    int i;
    int l;
!   char *buffer;
! 
      	
    Connect();
  
***************
*** 150,163 ****
      exit(1);
    }
    
!   if (dlp_OpenDB(sd, 0, dlpOpenRead, "Schlep", &db)<0)
!     return;
    
    for (i=0;
         (l = dlp_ReadResourceByType(sd, db, pi_mktag('D','A','T','A'), i, buffer, 0, 0)) > 0;
         i++) {
      write(fileno(stdout), buffer, l);
    }
  }
  
  void Help(void)
--- 159,176 ----
      exit(1);
    }
    
!   if(!(buffer = malloc(0xffff)))
!       exit(2);
  
+   if (dlp_OpenDB(sd, 0, dlpOpenRead, "Schlep", &db)>=0)
+   {
        for (i=0;
             (l = dlp_ReadResourceByType(sd, db, pi_mktag('D','A','T','A'), i, buffer, 0, 0)) > 0;
             i++) {
            write(fileno(stdout), buffer, l);
        }
+   }
+   free(buffer);
  }
  
  void Help(void)
diff -r -w -b -N -c /opt/src/pilot-link/pilot-xfer.c ./pilot-xfer.c
*** /opt/src/pilot-link/pilot-xfer.c	Thu Sep 11 18:57:15 1997
--- ./pilot-xfer.c	Sun Feb 28 19:33:32 1999
***************
*** 18,23 ****
--- 18,27 ----
  #include "pi-file.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "pilot-xfer";
+ #endif
+ 
  #define pi_mktag(c1,c2,c3,c4) (((c1)<<24)|((c2)<<16)|((c3)<<8)|(c4))
  
  int sd = 0;
***************
*** 217,224 ****
    else
      printf("OK\n");
    pi_file_close(f);
- 
-   printf("Fetch done.\n");
  }
  
  void Delete(char * dbname)
--- 221,226 ----
diff -r -w -b -N -c /opt/src/pilot-link/read-expenses.c ./read-expenses.c
*** /opt/src/pilot-link/read-expenses.c	Thu Sep 11 19:03:28 1997
--- ./read-expenses.c	Sun Feb 28 19:39:13 1999
***************
*** 14,19 ****
--- 14,23 ----
  #include "pi-expense.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "read-expenses";
+ #endif
+ 
                    
  int main(int argc, char *argv[])
  {
***************
*** 23,32 ****
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
!   unsigned char buffer2[0xffff];
    struct ExpenseAppInfo tai;
    struct ExpensePref tp;
    
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
--- 27,41 ----
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer;
!   unsigned char *buffer2;
    struct ExpenseAppInfo tai;
    struct ExpensePref tp;
+ 
+   if(!(buffer = malloc(0xffff)))
+       exit(2);
+   if(!(buffer2 = malloc(0xffff)))
+       exit(2);
    
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/read-todos.c ./read-todos.c
*** /opt/src/pilot-link/read-todos.c	Thu Sep 11 19:06:58 1997
--- ./read-todos.c	Sun Feb 28 19:40:43 1999
***************
*** 14,19 ****
--- 14,23 ----
  #include "pi-todo.h"
  #include "pi-dlp.h"
  
+ #ifdef QDOS
+ char _prog_name[] = "read-todos";
+ #endif
+ 
                    
  int main(int argc, char *argv[])
  {
***************
*** 23,30 ****
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
    struct ToDoAppInfo tai;
  
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
--- 27,36 ----
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer;
    struct ToDoAppInfo tai;
+   buffer = malloc(0xffff);
+   if(!buffer) exit(2);
    
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
diff -r -w -b -N -c /opt/src/pilot-link/reminders.c ./reminders.c
*** /opt/src/pilot-link/reminders.c	Thu Sep 11 19:06:06 1997
--- ./reminders.c	Sun Feb 28 19:39:31 1999
***************
*** 17,22 ****
--- 17,26 ----
  char *Weekday[7] = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
  char *Month[12] = {"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"};
  
+ #ifdef QDOS
+ char _prog_name[] = "reminders";
+ #endif
+ 
  int main(int argc, char *argv[])
  {
    struct pi_sockaddr addr;
***************
*** 25,31 ****
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char buffer[0xffff];
  
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
--- 29,37 ----
    int i;
    struct PilotUser U;
    int ret;
!   unsigned char *buffer;
! 
!   buffer = malloc(0xffff);
  
    if (argc < 2) {
      fprintf(stderr,"usage:%s %s\n",argv[0],TTYPrompt);
